	.module RS232.c
	.area text(rom, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\RS232.c
	.dbfunc e uart0_init _uart0_init fV
	.even
_uart0_init::
	.dbline -1
	.dbline 21
; #include <iom8v.h>
; #include <macros.h>
; #include <stdlib.h>
; #include "SPI_MAX7221.h"
; #include "TWI_DS1307.h"
; #include "var.h"
; #include "in_out.h"
; #include "eeprom.h"
; 
; void uart0_init(void);
; void re2rx(void);
; void rs232_handler(void);
; unsigned char rx2ds(unsigned char ind_mas);
; 
; //UART0 initialize
; // desired baud rate: 37500
; // actual: baud rate:37500 (0,0%)
; // char size: 8 bit
; // parity: Even
; void uart0_init(void)
; {
	.dbline 22
;  UCSRB = 0x00; //disable while setting baud rate
	clr R2
	out 0xa,R2
	.dbline 23
;  UCSRA = 0x00;
	out 0xb,R2
	.dbline 24
;  UCSRC = BIT(URSEL) | 0x26;
	ldi R24,166
	out 0x20,R24
	.dbline 25
;  UBRRL = 0x09; //set baud rate lo
	ldi R24,9
	out 0x9,R24
	.dbline 26
;  UBRRH = 0x00; //set baud rate hi
	out 0x20,R2
	.dbline 27
;  UCSRB = 0x90;// +,  +
	ldi R24,144
	out 0xa,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 22
	rjmp _uart0_rx_isr
	.area text(rom, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\RS232.c
	.dbfunc e uart0_rx_isr _uart0_rx_isr fV
	.even
_uart0_rx_isr::
	st -y,R2
	st -y,R24
	st -y,R25
	st -y,R30
	st -y,R31
	in R2,0x3f
	st -y,R2
	rcall push_gset2
	.dbline -1
	.dbline 32
; }
; 
; #pragma interrupt_handler uart0_rx_isr:12
; void uart0_rx_isr(void)
; {
	.dbline 34
;  //uart has received a character in UDR
;  	rx_mas[rx_s] = UDR;
	ldi R24,<_rx_mas
	ldi R25,>_rx_mas
	lds R30,_rx_s
	clr R31
	add R30,R24
	adc R31,R25
	in R2,0xc
	std z+0,R2
	.dbline 35
; 	rx_s++;
	lds R24,_rx_s
	subi R24,255    ; addi 1
	sts _rx_s,R24
	.dbline 36
; 	rs232_count = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	sts _rs232_count+1,R21
	sts _rs232_count,R20
	sts _rs232_count+2+1,R23
	sts _rs232_count+2,R22
	.dbline 37
; 	f_rs232 |= 0x02;
	lds R24,_f_rs232
	ori R24,2
	sts _f_rs232,R24
	.dbline -2
L2:
	rcall pop_gset2
	ld R2,y+
	out 0x3f,R2
	ld R31,y+
	ld R30,y+
	ld R25,y+
	ld R24,y+
	ld R2,y+
	.dbline 0 ; func end
	reti
	.dbend
	.area vector(rom, abs)
	.org 26
	rjmp _uart0_tx_isr
	.area text(rom, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\RS232.c
	.dbfunc e uart0_tx_isr _uart0_tx_isr fV
	.even
_uart0_tx_isr::
	st -y,R2
	st -y,R3
	st -y,R24
	st -y,R25
	st -y,R30
	st -y,R31
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 42
; }
; 
; #pragma interrupt_handler uart0_tx_isr:14
; void uart0_tx_isr(void)
; {
	.dbline 44
;  //character has been transmitted
;  	if(tx_count == tx_s)
	lds R2,_tx_s
	lds R3,_tx_count
	cp R3,R2
	brne L4
	.dbline 45
; 	{
	.dbline 46
; 		UCSRB = 0x90;// +,  +
	ldi R24,144
	out 0xa,R24
	.dbline 47
;   		tx_s = 0;
	clr R2
	sts _tx_s,R2
	.dbline 48
;   		tx_count = 0;
	sts _tx_count,R2
	.dbline 49
;  	}
	rjmp L5
L4:
	.dbline 51
	.dbline 52
	ldi R24,<_tx_mas
	ldi R25,>_tx_mas
	lds R30,_tx_count
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	out 0xc,R2
	.dbline 53
	lds R24,_tx_count
	subi R24,255    ; addi 1
	sts _tx_count,R24
	.dbline 54
L5:
	.dbline -2
L3:
	ld R2,y+
	out 0x3f,R2
	ld R31,y+
	ld R30,y+
	ld R25,y+
	ld R24,y+
	ld R3,y+
	ld R2,y+
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e re2rx _re2rx fV
	.even
_re2rx::
	.dbline -1
	.dbline 58
;  	else
; 	{
; 		UDR = tx_mas[tx_count];
; 		tx_count++;
;  	}
; }
; 
; void re2rx(void)
; {
	.dbline 59
;  	UCSRB = 0x90;// +,  +
	ldi R24,144
	out 0xa,R24
	.dbline 60
;  	rx_s = 0;
	clr R2
	sts _rx_s,R2
	.dbline 61
;  	rx_mas[rx_s] = UDR;
	ldi R24,<_rx_mas
	ldi R25,>_rx_mas
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	in R2,0xc
	std z+0,R2
	.dbline 62
;  	tx_s = 0;
	clr R2
	sts _tx_s,R2
	.dbline 63
;  	f_rs232 &= 0xFC;//  
	lds R24,_f_rs232
	andi R24,252
	sts _f_rs232,R24
	.dbline -2
L6:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e rs232_handler _rs232_handler fV
;         temp_j -> R12
;         temp_i -> R10
	.even
_rs232_handler::
	rcall push_gset4
	sbiw R28,2
	.dbline -1
	.dbline 67
; }
; 
; void rs232_handler(void)
; {
	.dbline 68
;  	unsigned char temp_i = 0, temp_j = 0;
	clr R10
	.dbline 68
	clr R12
	.dbline 69
; 	if(f_rs232&0x01)//  
	lds R2,_f_rs232
	sbrs R2,0
	rjmp L8
	.dbline 70
; 	{
	.dbline 71
; 	 	if((rx_s < 3)||(rx_s > 102)||(rx_mas[0] != 0x32)||(rx_mas[1] != rx_s))
	lds R24,_rx_s
	cpi R24,3
	brlo L15
	ldi R24,102
	lds R2,_rx_s
	cp R24,R2
	brlo L15
	lds R24,_rx_mas
	cpi R24,50
	brne L15
	lds R3,_rx_mas+1
	cp R3,R2
	breq L10
L15:
	.dbline 72
; 		{
	.dbline 73
; 		 	re2rx();
	rcall _re2rx
	.dbline 74
; 			return;
	rjmp L7
L10:
	.dbline 76
; 		}
; 		wr_int2max(0x0A, 0x00);// 
	clr R18
	ldi R16,10
	rcall _wr_int2max
	.dbline 77
; 		TCCR1B = 0x11;// 
	ldi R24,17
	out 0x2e,R24
	.dbline 78
; 		OCR1AH = 0x00;
	clr R2
	out 0x2b,R2
	.dbline 79
;  		OCR1AL = 0xF0;
	ldi R24,240
	out 0x2a,R24
	.dbline 80
; 		if(rx_mas[2] == 0x00)// 
	lds R2,_rx_mas+2
	tst R2
	brne L16
	.dbline 81
; 		{
	.dbline 82
; 			tx_s = 3;
	ldi R24,3
	sts _tx_s,R24
	.dbline 83
	clr R10
	inc R10
	rjmp L22
L19:
	.dbline 83
	ldi R24,<_rx_mas
	ldi R25,>_rx_mas
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_tx_mas
	ldi R25,>_tx_mas
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
L20:
	.dbline 83
	inc R10
L22:
	.dbline 83
; 			for(temp_i = 1; temp_i < rx_s; temp_i++) tx_mas[temp_i] = rx_mas[temp_i];
	lds R2,_rx_s
	cp R10,R2
	brlo L19
	.dbline 84
; 		}
L16:
	.dbline 85
; 		if(rx_mas[2] == 0x01)// 
	lds R24,_rx_mas+2
	cpi R24,1
	breq X0
	rjmp L23
X0:
	.dbline 86
; 		{
	.dbline 87
; 			WR_DS1307(addr_hours, rx2ds(3));
	ldi R16,3
	rcall _rx2ds
	mov R18,R16
	ldi R16,2
	rcall _WR_DS1307
	.dbline 88
; 			WR_DS1307(addr_mins, rx2ds(4));
	ldi R16,4
	rcall _rx2ds
	mov R18,R16
	ldi R16,1
	rcall _WR_DS1307
	.dbline 89
; 			WR_DS1307(addr_secs, rx2ds(5));
	ldi R16,5
	rcall _rx2ds
	mov R18,R16
	clr R16
	rcall _WR_DS1307
	.dbline 90
; 			WR_DS1307(addr_day, rx2ds(6));
	ldi R16,6
	rcall _rx2ds
	mov R18,R16
	ldi R16,3
	rcall _WR_DS1307
	.dbline 91
; 			WR_DS1307(addr_date, rx2ds(7));
	ldi R16,7
	rcall _rx2ds
	mov R18,R16
	ldi R16,4
	rcall _WR_DS1307
	.dbline 92
; 			WR_DS1307(addr_mons, rx2ds(8));
	ldi R16,8
	rcall _rx2ds
	mov R18,R16
	ldi R16,5
	rcall _WR_DS1307
	.dbline 93
; 			WR_DS1307(addr_years, rx2ds(9));
	ldi R16,9
	rcall _rx2ds
	mov R18,R16
	ldi R16,6
	rcall _WR_DS1307
	.dbline 94
; 			tx_s = 10;
	ldi R24,10
	sts _tx_s,R24
	.dbline 95
	clr R10
	inc R10
	rjmp L29
L26:
	.dbline 95
	ldi R24,<_rx_mas
	ldi R25,>_rx_mas
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_tx_mas
	ldi R25,>_tx_mas
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
L27:
	.dbline 95
	inc R10
L29:
	.dbline 95
; 			for(temp_i = 1; temp_i < rx_s; temp_i++) tx_mas[temp_i] = rx_mas[temp_i];
	lds R2,_rx_s
	cp R10,R2
	brlo L26
	.dbline 96
; 		}
L23:
	.dbline 97
; 		if(rx_mas[2] == 0x02)// 
	lds R24,_rx_mas+2
	cpi R24,2
	brne L30
	.dbline 98
; 		{
	.dbline 99
; 		 	WR_DS1307(addr_secs, 0);
	clr R18
	clr R16
	rcall _WR_DS1307
	.dbline 100
; 			tx_s = 3;
	ldi R24,3
	sts _tx_s,R24
	.dbline 101
	clr R10
	inc R10
	rjmp L36
L33:
	.dbline 101
	ldi R24,<_rx_mas
	ldi R25,>_rx_mas
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_tx_mas
	ldi R25,>_tx_mas
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
L34:
	.dbline 101
	inc R10
L36:
	.dbline 101
; 			for(temp_i = 1; temp_i < rx_s; temp_i++) tx_mas[temp_i] = rx_mas[temp_i];
	lds R2,_rx_s
	cp R10,R2
	brlo L33
	.dbline 102
; 		}
L30:
	.dbline 103
; 		if(rx_mas[2] == 0x03)// 
	lds R24,_rx_mas+2
	cpi R24,3
	breq X1
	rjmp L37
X1:
	.dbline 104
; 		{
	.dbline 105
; 			for(temp_i = 0; temp_i < 16; temp_i++)
	clr R10
	rjmp L43
L40:
	.dbline 106
	.dbline 107
	ldi R24,5
	mul R24,R10
	movw R30,R0
	ldi R24,<_rx_mas+3
	ldi R25,>_rx_mas+3
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_mas_type_alarm
	ldi R25,>_mas_type_alarm
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 108
	ldi R24,5
	mul R24,R10
	movw R30,R0
	ldi R24,<_rx_mas+4
	ldi R25,>_rx_mas+4
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_mas_hour_alarm
	ldi R25,>_mas_hour_alarm
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 109
	ldi R24,5
	mul R24,R10
	movw R30,R0
	ldi R24,<_rx_mas+5
	ldi R25,>_rx_mas+5
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_mas_min_alarm
	ldi R25,>_mas_min_alarm
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 110
	ldi R24,5
	mul R24,R10
	movw R30,R0
	ldi R24,<_rx_mas+6
	ldi R25,>_rx_mas+6
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_mas_date_alarm
	ldi R25,>_mas_date_alarm
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 111
	ldi R24,5
	mul R24,R10
	movw R30,R0
	ldi R24,<_rx_mas+7
	ldi R25,>_rx_mas+7
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_mas_mon_alarm
	ldi R25,>_mas_mon_alarm
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 112
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R24,<_mas_type_alarm
	ldi R25,>_mas_type_alarm
	mov R18,R10
	clr R19
	add R18,R24
	adc R19,R25
	ldi R24,<_EE_type_alarm
	ldi R25,>_EE_type_alarm
	mov R16,R10
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMWriteBytes
	.dbline 113
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R24,<_mas_hour_alarm
	ldi R25,>_mas_hour_alarm
	mov R18,R10
	clr R19
	add R18,R24
	adc R19,R25
	ldi R24,<_EE_hour_alarm
	ldi R25,>_EE_hour_alarm
	mov R16,R10
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMWriteBytes
	.dbline 114
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R24,<_mas_min_alarm
	ldi R25,>_mas_min_alarm
	mov R18,R10
	clr R19
	add R18,R24
	adc R19,R25
	ldi R24,<_EE_min_alarm
	ldi R25,>_EE_min_alarm
	mov R16,R10
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMWriteBytes
	.dbline 115
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R24,<_mas_date_alarm
	ldi R25,>_mas_date_alarm
	mov R18,R10
	clr R19
	add R18,R24
	adc R19,R25
	ldi R24,<_EE_date_alarm
	ldi R25,>_EE_date_alarm
	mov R16,R10
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMWriteBytes
	.dbline 116
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R24,<_mas_mon_alarm
	ldi R25,>_mas_mon_alarm
	mov R18,R10
	clr R19
	add R18,R24
	adc R19,R25
	ldi R24,<_EE_mon_alarm
	ldi R25,>_EE_mon_alarm
	mov R16,R10
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMWriteBytes
	.dbline 117
L41:
	.dbline 105
	inc R10
L43:
	.dbline 105
	mov R24,R10
	cpi R24,16
	brsh X2
	rjmp L40
X2:
	.dbline 118
; 			{
; 			 	mas_type_alarm[temp_i] = rx_mas[3 + (temp_i * 5)];
; 				mas_hour_alarm[temp_i] = rx_mas[4 + (temp_i * 5)];
; 				mas_min_alarm[temp_i] = rx_mas[5 + (temp_i * 5)];
; 				mas_date_alarm[temp_i] = rx_mas[6 + (temp_i * 5)];
; 				mas_mon_alarm[temp_i] = rx_mas[7 + (temp_i * 5)];
; 				EEPROM_WRITE((int)&EE_type_alarm[temp_i], mas_type_alarm[temp_i]);
; 				EEPROM_WRITE((int)&EE_hour_alarm[temp_i], mas_hour_alarm[temp_i]);
; 				EEPROM_WRITE((int)&EE_min_alarm[temp_i], mas_min_alarm[temp_i]);
; 				EEPROM_WRITE((int)&EE_date_alarm[temp_i], mas_date_alarm[temp_i]);
; 				EEPROM_WRITE((int)&EE_mon_alarm[temp_i], mas_mon_alarm[temp_i]);
; 			}
; 			len_alarm = rx_mas[83];
	lds R2,_rx_mas+83
	sts _len_alarm,R2
	.dbline 119
; 			EEPROM_WRITE((int)&EE_len_alarm, len_alarm);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_len_alarm
	ldi R19,>_len_alarm
	ldi R16,<_EE_len_alarm
	ldi R17,>_EE_len_alarm
	rcall _EEPROMWriteBytes
	.dbline 120
; 			tx_s = 84;
	ldi R24,84
	sts _tx_s,R24
	.dbline 121
	clr R10
	inc R10
	rjmp L53
L50:
	.dbline 121
	ldi R24,<_rx_mas
	ldi R25,>_rx_mas
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_tx_mas
	ldi R25,>_tx_mas
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
L51:
	.dbline 121
	inc R10
L53:
	.dbline 121
; 			for(temp_i = 1; temp_i < rx_s; temp_i++) tx_mas[temp_i] = rx_mas[temp_i];
	lds R2,_rx_s
	cp R10,R2
	brlo L50
	.dbline 122
; 		}
L37:
	.dbline 123
; 		if(rx_mas[2] == 0xA1)// 
	lds R24,_rx_mas+2
	cpi R24,161
	brne L54
	.dbline 124
; 		{
	.dbline 125
; 			tx_mas[3] = ((hour_1 * 10) + hour_2);
	lds R2,_hour_1
	ldi R24,10
	mul R24,R2
	lds R2,_hour_2
	mov R3,R0
	add R3,R2
	sts _tx_mas+3,R3
	.dbline 126
; 			tx_mas[4] = ((min_1 * 10) + min_2);
	lds R2,_min_1
	mul R24,R2
	lds R2,_min_2
	mov R3,R0
	add R3,R2
	sts _tx_mas+4,R3
	.dbline 127
; 			tx_mas[5] = ((date_1 * 10) + date_2);
	lds R2,_date_1
	mul R24,R2
	lds R2,_date_2
	mov R3,R0
	add R3,R2
	sts _tx_mas+5,R3
	.dbline 128
; 			tx_mas[6] = ((mon_1 * 10) + mon_2);
	lds R2,_mon_1
	mul R24,R2
	lds R2,_mon_2
	mov R3,R0
	add R3,R2
	sts _tx_mas+6,R3
	.dbline 129
; 			tx_mas[7] = ((year_1 * 10) + year_2);
	lds R2,_year_1
	mul R24,R2
	lds R2,_year_2
	mov R3,R0
	add R3,R2
	sts _tx_mas+7,R3
	.dbline 130
; 			tx_s = 8;
	ldi R24,8
	sts _tx_s,R24
	.dbline 131
; 		}
L54:
	.dbline 132
; 		if(rx_mas[2] == 0xA3)// 
	lds R24,_rx_mas+2
	cpi R24,163
	breq X3
	rjmp L62
X3:
	.dbline 133
; 		{
	.dbline 134
; 			read_eeprom_data();
	rcall _read_eeprom_data
	.dbline 135
; 			for(temp_i = 0; temp_i < 16; temp_i++)
	clr R10
	rjmp L68
L65:
	.dbline 136
	.dbline 137
	ldi R24,5
	mul R24,R10
	movw R30,R0
	ldi R24,<_tx_mas+3
	ldi R25,>_tx_mas+3
	add R30,R24
	adc R31,R25
	ldi R24,<_mas_type_alarm
	ldi R25,>_mas_type_alarm
	mov R26,R10
	clr R27
	add R26,R24
	adc R27,R25
	ld R2,x
	std z+0,R2
	.dbline 138
	ldi R24,5
	mul R24,R10
	movw R30,R0
	ldi R24,<_tx_mas+4
	ldi R25,>_tx_mas+4
	add R30,R24
	adc R31,R25
	ldi R24,<_mas_hour_alarm
	ldi R25,>_mas_hour_alarm
	mov R26,R10
	clr R27
	add R26,R24
	adc R27,R25
	ld R2,x
	std z+0,R2
	.dbline 139
	ldi R24,5
	mul R24,R10
	movw R30,R0
	ldi R24,<_tx_mas+5
	ldi R25,>_tx_mas+5
	add R30,R24
	adc R31,R25
	ldi R24,<_mas_min_alarm
	ldi R25,>_mas_min_alarm
	mov R26,R10
	clr R27
	add R26,R24
	adc R27,R25
	ld R2,x
	std z+0,R2
	.dbline 140
	ldi R24,5
	mul R24,R10
	movw R30,R0
	ldi R24,<_tx_mas+6
	ldi R25,>_tx_mas+6
	add R30,R24
	adc R31,R25
	ldi R24,<_mas_date_alarm
	ldi R25,>_mas_date_alarm
	mov R26,R10
	clr R27
	add R26,R24
	adc R27,R25
	ld R2,x
	std z+0,R2
	.dbline 141
	ldi R24,5
	mul R24,R10
	movw R30,R0
	ldi R24,<_tx_mas+7
	ldi R25,>_tx_mas+7
	add R30,R24
	adc R31,R25
	ldi R24,<_mas_mon_alarm
	ldi R25,>_mas_mon_alarm
	mov R26,R10
	clr R27
	add R26,R24
	adc R27,R25
	ld R2,x
	std z+0,R2
	.dbline 142
L66:
	.dbline 135
	inc R10
L68:
	.dbline 135
	mov R24,R10
	cpi R24,16
	brsh X4
	rjmp L65
X4:
	.dbline 143
; 			{
; 				tx_mas[3 + (temp_i * 5)] = mas_type_alarm[temp_i];
; 				tx_mas[4 + (temp_i * 5)] = mas_hour_alarm[temp_i];
; 				tx_mas[5 + (temp_i * 5)] = mas_min_alarm[temp_i];
; 				tx_mas[6 + (temp_i * 5)] = mas_date_alarm[temp_i];
; 				tx_mas[7 + (temp_i * 5)] = mas_mon_alarm[temp_i];
; 			}
; 			tx_mas[83] = len_alarm;
	lds R2,_len_alarm
	sts _tx_mas+83,R2
	.dbline 144
; 			tx_s = 84;
	ldi R24,84
	sts _tx_s,R24
	.dbline 145
; 		}
L62:
	.dbline 146
	ldi R24,69
	sts _tx_mas,R24
	.dbline 147
	clr R2
	sts _rx_s,R2
	.dbline 148
	ldi R24,72
	out 0xa,R24
	.dbline 149
	ldi R24,1
	sts _tx_count,R24
	.dbline 150
	lds R2,_tx_mas
	out 0xc,R2
	.dbline 151
	lds R24,_f_rs232
	andi R24,252
	sts _f_rs232,R24
	.dbline 152
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	sts _rs232_count+1,R21
	sts _rs232_count,R20
	sts _rs232_count+2+1,R23
	sts _rs232_count+2,R22
	.dbline 153
	ldi R18,255
	ldi R16,10
	rcall _wr_int2max
	.dbline 154
	clr R2
	out 0x2e,R2
	.dbline 155
L8:
	.dbline -2
L7:
	adiw R28,2
	rcall pop_gset4
	.dbline 0 ; func end
	ret
	.dbsym r temp_j 12 c
	.dbsym r temp_i 10 c
	.dbend
	.dbfunc e rx2ds _rx2ds fc
;        ind_mas -> R20
	.even
_rx2ds::
	rcall push_gset1
	mov R20,R16
	.dbline -1
	.dbline 159
; 		tx_mas[0] = 0x45;
; 		rx_s = 0;
; 		UCSRB = 0x48;// +,  +
; 		tx_count = 1;
; 		UDR = tx_mas[0];
; 		f_rs232 &= 0xFC;//  
; 		rs232_count = 0;
; 		wr_int2max(0x0A, 0xFF);// 
; 		TCCR1B = 0x00;// 
; 	}
; }
; 
; unsigned char rx2ds(unsigned char ind_mas)
; {
	.dbline 160
; 	return (((rx_mas[ind_mas] / 10) << 4) | (rx_mas[ind_mas] - ((rx_mas[ind_mas] / 10) * 10)));
	ldi R24,<_rx_mas
	ldi R25,>_rx_mas
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	clr R3
	ldi R18,10
	ldi R19,0
	mov R16,R2
	clr R17
	rcall div16s
	movw R4,R16
	ldi R16,10
	ldi R17,0
	movw R18,R4
	rcall empy16s
	clr R3
	sub R2,R16
	sbc R3,R17
	mov R16,R4
	lsl R16
	rol R17
	lsl R16
	rol R17
	lsl R16
	rol R17
	lsl R16
	rol R17
	or R16,R2
	or R17,R3
	.dbline -2
L75:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r ind_mas 20 c
	.dbend
