#include <iom8v.h>
#include <macros.h>
#include "var.h"

void wr_int2max(unsigned char data_1, unsigned char data_2);
void init_display(void);
void show_dig_1(unsigned char dig_1, unsigned char dig_2, unsigned char dig_3, unsigned char dig_4);
void show_dig_2(unsigned char dig_1, unsigned char dig_2, unsigned char dig_3, unsigned char dig_4);

void wr_int2max(unsigned char data_1, unsigned char data_2)
{
	SPCR = 0x50;// SPI
	PORTB &= 0xFE;
	SPDR = data_1;
	while(!(SPSR&0x80)) WDR();
	SPDR = data_2;
	while(!(SPSR&0x80)) WDR();
	PORTB |= 0x01;
	SPCR = 0x00;// SPI
}

void init_display(void)
{
 	unsigned char temp_i = 0;
  	wr_int2max(0x0C, 0x00);//. 
	wr_int2max(0x0C, 0x01);//. 
	wr_int2max(0x0A, 0xFF);// 
	wr_int2max(0x09, 0xFF);// .
	wr_int2max(0x0B, 0x07);//0-7 
	for(temp_i = 1; temp_i < 9; temp_i++) wr_int2max(temp_i, 0x7F);
}

void show_dig_1(unsigned char dig_1, unsigned char dig_2, unsigned char dig_3, unsigned char dig_4)
{
	wr_int2max(0x01, dig_1);
	wr_int2max(0x02, dig_2);
	wr_int2max(0x03, dig_3);
	wr_int2max(0x04, dig_4);
}

void show_dig_2(unsigned char dig_1, unsigned char dig_2, unsigned char dig_3, unsigned char dig_4)
{
	wr_int2max(0x05, dig_1);
	wr_int2max(0x06, dig_2);
	wr_int2max(0x07, dig_3);
	wr_int2max(0x08, dig_4);
}