	.module SPI_MAX7221.c
	.area text(rom, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\SPI_MAX7221.c
	.dbfunc e wr_int2max _wr_int2max fV
;         data_2 -> R18
;         data_1 -> R16
	.even
_wr_int2max::
	.dbline -1
	.dbline 11
; #include <iom8v.h>
; #include <macros.h>
; #include "var.h"
; 
; void wr_int2max(unsigned char data_1, unsigned char data_2);
; void init_display(void);
; void show_dig_1(unsigned char dig_1, unsigned char dig_2, unsigned char dig_3, unsigned char dig_4);
; void show_dig_2(unsigned char dig_1, unsigned char dig_2, unsigned char dig_3, unsigned char dig_4);
; 
; void wr_int2max(unsigned char data_1, unsigned char data_2)
; {
	.dbline 12
; 	SPCR = 0x50;// SPI
	ldi R24,80
	out 0xd,R24
	.dbline 13
; 	PORTB &= 0xFE;
	in R24,0x18
	andi R24,254
	out 0x18,R24
	.dbline 14
; 	SPDR = data_1;
	out 0xf,R16
	rjmp L3
L2:
	.dbline 15
	wdr
L3:
	.dbline 15
; 	while(!(SPSR&0x80)) WDR();
	sbis 0xe,7
	rjmp L2
	.dbline 16
; 	SPDR = data_2;
	out 0xf,R18
	rjmp L6
L5:
	.dbline 17
	wdr
L6:
	.dbline 17
; 	while(!(SPSR&0x80)) WDR();
	sbis 0xe,7
	rjmp L5
	.dbline 18
; 	PORTB |= 0x01;
	sbi 0x18,0
	.dbline 19
; 	SPCR = 0x00;// SPI
	clr R2
	out 0xd,R2
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym r data_2 18 c
	.dbsym r data_1 16 c
	.dbend
	.dbfunc e init_display _init_display fV
;         temp_i -> R20
	.even
_init_display::
	rcall push_gset1
	.dbline -1
	.dbline 23
; }
; 
; void init_display(void)
; {
	.dbline 24
;  	unsigned char temp_i = 0;
	clr R20
	.dbline 25
;   	wr_int2max(0x0C, 0x00);//. 
	clr R18
	ldi R16,12
	rcall _wr_int2max
	.dbline 26
; 	wr_int2max(0x0C, 0x01);//. 
	ldi R18,1
	ldi R16,12
	rcall _wr_int2max
	.dbline 27
; 	wr_int2max(0x0A, 0xFF);// 
	ldi R18,255
	ldi R16,10
	rcall _wr_int2max
	.dbline 28
; 	wr_int2max(0x09, 0xFF);// .
	ldi R18,255
	ldi R16,9
	rcall _wr_int2max
	.dbline 29
; 	wr_int2max(0x0B, 0x07);//0-7 
	ldi R18,7
	ldi R16,11
	rcall _wr_int2max
	.dbline 30
	ldi R20,1
	rjmp L12
L9:
	.dbline 30
	ldi R18,127
	mov R16,R20
	rcall _wr_int2max
L10:
	.dbline 30
	inc R20
L12:
	.dbline 30
; 	for(temp_i = 1; temp_i < 9; temp_i++) wr_int2max(temp_i, 0x7F);
	cpi R20,9
	brlo L9
	.dbline -2
L8:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r temp_i 20 c
	.dbend
	.dbfunc e show_dig_1 _show_dig_1 fV
;          dig_4 -> y+6
;          dig_3 -> y+4
;          dig_2 -> R20
;          dig_1 -> R22
	.even
_show_dig_1::
	rcall push_gset2
	mov R20,R18
	mov R22,R16
	.dbline -1
	.dbline 34
; }
; 
; void show_dig_1(unsigned char dig_1, unsigned char dig_2, unsigned char dig_3, unsigned char dig_4)
; {
	.dbline 35
; 	wr_int2max(0x01, dig_1);
	mov R18,R22
	ldi R16,1
	rcall _wr_int2max
	.dbline 36
; 	wr_int2max(0x02, dig_2);
	mov R18,R20
	ldi R16,2
	rcall _wr_int2max
	.dbline 37
; 	wr_int2max(0x03, dig_3);
	ldd R18,y+4
	ldi R16,3
	rcall _wr_int2max
	.dbline 38
; 	wr_int2max(0x04, dig_4);
	ldd R18,y+6
	ldi R16,4
	rcall _wr_int2max
	.dbline -2
L13:
	rcall pop_gset2
	.dbline 0 ; func end
	ret
	.dbsym l dig_4 6 c
	.dbsym l dig_3 4 c
	.dbsym r dig_2 20 c
	.dbsym r dig_1 22 c
	.dbend
	.dbfunc e show_dig_2 _show_dig_2 fV
;          dig_4 -> y+6
;          dig_3 -> y+4
;          dig_2 -> R20
;          dig_1 -> R22
	.even
_show_dig_2::
	rcall push_gset2
	mov R20,R18
	mov R22,R16
	.dbline -1
	.dbline 42
; }
; 
; void show_dig_2(unsigned char dig_1, unsigned char dig_2, unsigned char dig_3, unsigned char dig_4)
; {
	.dbline 43
; 	wr_int2max(0x05, dig_1);
	mov R18,R22
	ldi R16,5
	rcall _wr_int2max
	.dbline 44
; 	wr_int2max(0x06, dig_2);
	mov R18,R20
	ldi R16,6
	rcall _wr_int2max
	.dbline 45
; 	wr_int2max(0x07, dig_3);
	ldd R18,y+4
	ldi R16,7
	rcall _wr_int2max
	.dbline 46
; 	wr_int2max(0x08, dig_4);
	ldd R18,y+6
	ldi R16,8
	rcall _wr_int2max
	.dbline -2
L14:
	rcall pop_gset2
	.dbline 0 ; func end
	ret
	.dbsym l dig_4 6 c
	.dbsym l dig_3 4 c
	.dbsym r dig_2 20 c
	.dbsym r dig_1 22 c
	.dbend
