/*
**  Header file : eeprom.h
*/


extern void EEPROMReadBytes(int addr, void *ptr, int size);
extern void EEPROMWriteBytes(int addr, void *ptr, int size);

unsigned char EEPROMread(int);

#define EEPROM_READ(addr, dst)		EEPROMReadBytes(addr, &dst, sizeof (dst))
#define EEPROM_WRITE(addr, src)		EEPROMWriteBytes(addr, &src, sizeof (src))

