	.module in_out.c
	.area text(rom, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\in_out.c
	.dbfunc e VDs _VDs fV
;         on_off -> R16
	.even
_VDs::
	.dbline -1
	.dbline 19
; #include <iom8v.h>
; #include <macros.h>
; #include "var.h"
; #include "SPI_MAX7221.h"
; #include "TWI_DS1307.h"
; #include "eeprom.h"
; 
; void VDs(unsigned char on_off);/// 
; unsigned char keys(void);
; void sets(void);
; void wr_dec_data2DS1307(unsigned char addr, unsigned char min_val, unsigned char max_val);
; void wr_inc_data2DS1307(unsigned char addr, unsigned char min_val, unsigned char max_val);
; void exit_sets(void);
; void update_alarm_1(void);
; void update_alarm_2(void);
; void read_eeprom_data(void);
; 
; void VDs(unsigned char on_off)/// 
; {
	.dbline 20
;  	if(on_off)
	tst R16
	breq L2
	.dbline 21
; 	{
	.dbline 22
; 	 	PORTD &= 0x3F;// VD2-3
	in R24,0x12
	andi R24,63
	out 0x12,R24
	.dbline 23
; 		f_VDs |= 0x01;
	lds R24,_f_VDs
	ori R24,1
	sts _f_VDs,R24
	.dbline 24
; 	}
	rjmp L3
L2:
	.dbline 26
	.dbline 27
	in R24,0x12
	ori R24,192
	out 0x12,R24
	.dbline 28
	lds R24,_f_VDs
	andi R24,254
	sts _f_VDs,R24
	.dbline 29
L3:
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym r on_off 16 c
	.dbend
	.dbfunc e keys _keys fc
;         temp_i -> R16
	.even
_keys::
	rcall push_gset2
	.dbline -1
	.dbline 33
; 	else
; 	{
; 	 	PORTD |= 0xC0;// VD2-3
; 		f_VDs &= 0xFE;
; 	}
; }
; 
; unsigned char keys(void)//  
; {
	.dbline 34
;  	unsigned char temp_i = 0;
	clr R16
	.dbline 35
; 	if(keys_count >= d_keys)//    
	ldi R20,32
	ldi R21,161
	ldi R22,7
	ldi R23,0
	lds R4,_keys_count+2
	lds R5,_keys_count+2+1
	lds R2,_keys_count
	lds R3,_keys_count+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brlo L5
	.dbline 36
; 	{
	.dbline 37
; 		if(!(PIND&0x20)) temp_i |= 0x08;//  SB1(4)
	sbic 0x10,5
	rjmp L7
	.dbline 37
	ori R16,8
	rjmp L8
L7:
	.dbline 38
; 		else if(!(PINC&0x02)) temp_i |= 0x04;//  SB2(3)
	sbic 0x13,1
	rjmp L9
	.dbline 38
	ori R16,4
	rjmp L10
L9:
	.dbline 39
; 		 	 else if(!(PINC&0x04)) temp_i |= 0x02;//  SB3(2)
	sbic 0x13,2
	rjmp L11
	.dbline 39
	ori R16,2
	rjmp L12
L11:
	.dbline 40
; 		 	  	  else if(!(PINC&0x08)) temp_i |= 0x01;//  SB4(1)
	sbic 0x13,3
	rjmp L13
	.dbline 40
	ori R16,1
L13:
L12:
L10:
L8:
	.dbline 41
; 		if(temp_i) keys_count = 0;//    d_keys
	tst R16
	breq L15
	.dbline 41
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	sts _keys_count+1,R21
	sts _keys_count,R20
	sts _keys_count+2+1,R23
	sts _keys_count+2,R22
L15:
	.dbline 42
; 	}
L5:
	.dbline 43
; 	return temp_i;
	.dbline -2
L4:
	rcall pop_gset2
	.dbline 0 ; func end
	ret
	.dbsym r temp_i 16 c
	.dbend
	.dbfunc e sets _sets fV
;         temp_k -> R10
;         temp_i -> R22
;         temp_j -> R20
	.even
_sets::
	rcall push_gset3
	sbiw R28,2
	.dbline -1
	.dbline 47
; }
; 
; void sets(void)
; {
	.dbline 48
;  	unsigned char temp_i = 0, temp_j = 0, temp_k = 0;
	clr R22
	.dbline 48
	clr R20
	.dbline 48
	clr R10
	.dbline 49
; 	temp_i = keys();
	rcall _keys
	mov R22,R16
	.dbline 50
; 	if(temp_i)
	tst R16
	brne X0
	rjmp L17
X0:
	.dbline 51
; 	{
	.dbline 52
; 	 	flags |= 0x02;
	lds R24,_flags
	ori R24,2
	sts _flags,R24
	.dbline 53
; 		if(temp_i&0x01)//   
	sbrs R16,0
	rjmp L20
	.dbline 54
; 		{
	.dbline 55
; 		 	st_but[s_st_but] = 1;
	ldi R24,<_st_but
	ldi R25,>_st_but
	lds R30,_s_st_but
	clr R31
	add R30,R24
	adc R31,R25
	ldi R24,1
	std z+0,R24
	.dbline 56
; 		}
L20:
	.dbline 57
; 		if(temp_i&0x02)//   
	sbrs R22,1
	rjmp L22
	.dbline 58
; 		{
	.dbline 59
; 		 	st_but[s_st_but] = 2;
	ldi R24,<_st_but
	ldi R25,>_st_but
	lds R30,_s_st_but
	clr R31
	add R30,R24
	adc R31,R25
	ldi R24,2
	std z+0,R24
	.dbline 60
; 		}
L22:
	.dbline 61
; 		if(temp_i&0x04)//   
	sbrs R22,2
	rjmp L24
	.dbline 62
; 		{
	.dbline 63
; 		 	st_but[s_st_but] = 3;
	ldi R24,<_st_but
	ldi R25,>_st_but
	lds R30,_s_st_but
	clr R31
	add R30,R24
	adc R31,R25
	ldi R24,3
	std z+0,R24
	.dbline 64
; 		}
L24:
	.dbline 65
; 		if(temp_i&0x08)//   
	sbrs R22,3
	rjmp L26
	.dbline 66
; 		{
	.dbline 67
; 			st_but[s_st_but] = 4;
	ldi R24,<_st_but
	ldi R25,>_st_but
	lds R30,_s_st_but
	clr R31
	add R30,R24
	adc R31,R25
	ldi R24,4
	std z+0,R24
	.dbline 68
; 		}
L26:
	.dbline 69
; 		s_st_but++;
	lds R24,_s_st_but
	subi R24,255    ; addi 1
	sts _s_st_but,R24
	.dbline 70
; 	}
	.dbline 71
; 	else return;
L19:
	.dbline 73
; 	
; 	if(!s_st_but){
	lds R2,_s_st_but
	tst R2
	brne L28
	.dbline 73
	.dbline 74
; 		exit_sets();
	rcall _exit_sets
	.dbline 75
; 		return;
	rjmp L17
L28:
	.dbline 78
; 	}
; //-------------------------   -------------------------
; 	for(temp_i = 1; temp_i < 5; temp_i++)
	ldi R22,1
	rjmp L33
L30:
	.dbline 79
; 	{
	.dbline 80
; 		if(st_but[0] == temp_i)
	lds R2,_st_but
	cp R2,R22
	brne L34
	.dbline 81
; 		{
	.dbline 82
; 		 	for(temp_j = 0; temp_j < s_st_but; temp_j++)
	clr R20
	rjmp L39
L36:
	.dbline 83
; 			{
	.dbline 84
; 			 	if(st_but[temp_j] != temp_i)
	ldi R24,<_st_but
	ldi R25,>_st_but
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	cp R2,R22
	breq L40
	.dbline 85
; 				{
	.dbline 86
; 				 	break;
	rjmp L32
L40:
	.dbline 88
L37:
	.dbline 82
	inc R20
L39:
	.dbline 82
	lds R2,_s_st_but
	cp R20,R2
	brlo L36
	.dbline 89
; 				}
; 			}
; 			break;
	rjmp L32
L34:
	.dbline 91
L31:
	.dbline 78
	inc R22
L33:
	.dbline 78
	cpi R22,5
	brlo L30
L32:
	.dbline 93
; 		}
; 	}
; //-------------------------   -------------------------
; 	if(st_but[0] == 1)//  /
	lds R24,_st_but
	cpi R24,1
	breq X1
	rjmp L42
X1:
	.dbline 94
; 	{
	.dbline 95
; 	 	if(temp_j > 7)
	ldi R24,7
	cp R24,R20
	brsh L44
	.dbline 96
; 		{
	.dbline 97
; 		 	exit_sets();
	rcall _exit_sets
	.dbline 98
; 			return;
	rjmp L17
L44:
	.dbline 100
; 		}
; 		menu_st = temp_j;
	sts _menu_st,R20
	.dbline 101
; 		if(st_but[s_st_but - 1] == 2)//   
	ldi R24,<_st_but-1
	ldi R25,>_st_but-1
	lds R30,_s_st_but
	clr R31
	add R30,R24
	adc R31,R25
	ldd R24,z+0
	cpi R24,2
	breq X2
	rjmp L46
X2:
	.dbline 102
; 		{
	.dbline 103
; 		 	s_st_but--;
	lds R24,_s_st_but
	subi R24,1
	sts _s_st_but,R24
	.dbline 104
; 			if(menu_st == set_hours)
	cpi R20,1
	brne L49
	.dbline 105
; 			{
	.dbline 106
; 			 	wr_dec_data2DS1307(addr_hours, 0, 23);
	ldi R24,23
	std y+0,R24
	clr R18
	ldi R16,2
	rcall _wr_dec_data2DS1307
	.dbline 107
; 			}
L49:
	.dbline 108
; 			if(menu_st == set_mins)
	lds R24,_menu_st
	cpi R24,2
	brne L51
	.dbline 109
; 			{
	.dbline 110
; 			 	wr_dec_data2DS1307(addr_mins, 0, 59);
	ldi R24,59
	std y+0,R24
	clr R18
	ldi R16,1
	rcall _wr_dec_data2DS1307
	.dbline 111
; 			}
L51:
	.dbline 112
; 			if(menu_st == set_secs)
	lds R24,_menu_st
	cpi R24,3
	brne L53
	.dbline 113
; 			{
	.dbline 114
; 				WR_DS1307(addr_secs, 0);
	clr R18
	clr R16
	rcall _WR_DS1307
	.dbline 115
; 			}
L53:
	.dbline 116
; 			if(menu_st == set_date)
	lds R24,_menu_st
	cpi R24,4
	brne L55
	.dbline 117
; 			{
	.dbline 118
; 			 	wr_dec_data2DS1307(addr_date, 1, 31);
	ldi R24,31
	std y+0,R24
	ldi R18,1
	ldi R16,4
	rcall _wr_dec_data2DS1307
	.dbline 119
; 			}
L55:
	.dbline 120
; 			if(menu_st == set_day)
	lds R24,_menu_st
	cpi R24,5
	brne L57
	.dbline 121
; 			{
	.dbline 122
; 			 	wr_dec_data2DS1307(addr_day, 1, 7);
	ldi R24,7
	std y+0,R24
	ldi R18,1
	ldi R16,3
	rcall _wr_dec_data2DS1307
	.dbline 123
; 			}
L57:
	.dbline 124
; 			if(menu_st == set_mons)
	lds R24,_menu_st
	cpi R24,6
	brne L59
	.dbline 125
; 			{
	.dbline 126
; 			 	wr_dec_data2DS1307(addr_mons, 1, 12);
	ldi R24,12
	std y+0,R24
	ldi R18,1
	ldi R16,5
	rcall _wr_dec_data2DS1307
	.dbline 127
; 			}
L59:
	.dbline 128
; 			if(menu_st == set_years)
	lds R24,_menu_st
	cpi R24,7
	brne L61
	.dbline 129
; 			{
	.dbline 130
; 			 	wr_dec_data2DS1307(addr_years, 9, 29);
	ldi R24,29
	std y+0,R24
	ldi R18,9
	ldi R16,6
	rcall _wr_dec_data2DS1307
	.dbline 131
; 			}
L61:
	.dbline 132
; 			update_time();
	rcall _update_time
	.dbline 133
; 		}
L46:
	.dbline 134
; 		if(st_but[s_st_but - 1] == 3)//   
	ldi R24,<_st_but-1
	ldi R25,>_st_but-1
	lds R30,_s_st_but
	clr R31
	add R30,R24
	adc R31,R25
	ldd R24,z+0
	cpi R24,3
	breq X3
	rjmp L63
X3:
	.dbline 135
; 		{
	.dbline 136
; 		 	s_st_but--;
	lds R24,_s_st_but
	subi R24,1
	sts _s_st_but,R24
	.dbline 137
; 		 	if(menu_st == set_hours)
	lds R24,_menu_st
	cpi R24,1
	brne L66
	.dbline 138
; 			{
	.dbline 139
; 				wr_inc_data2DS1307(addr_hours, 0, 23);
	ldi R24,23
	std y+0,R24
	clr R18
	ldi R16,2
	rcall _wr_inc_data2DS1307
	.dbline 140
; 			}
L66:
	.dbline 141
; 			if(menu_st == set_mins)
	lds R24,_menu_st
	cpi R24,2
	brne L68
	.dbline 142
; 			{
	.dbline 143
; 			 	wr_inc_data2DS1307(addr_mins, 0, 59);
	ldi R24,59
	std y+0,R24
	clr R18
	ldi R16,1
	rcall _wr_inc_data2DS1307
	.dbline 144
; 			}
L68:
	.dbline 145
; 			if(menu_st == set_secs)
	lds R24,_menu_st
	cpi R24,3
	brne L70
	.dbline 146
; 			{
	.dbline 147
; 				WR_DS1307(addr_secs, 0);
	clr R18
	clr R16
	rcall _WR_DS1307
	.dbline 148
; 			}
L70:
	.dbline 149
; 			if(menu_st == set_date)
	lds R24,_menu_st
	cpi R24,4
	brne L72
	.dbline 150
; 			{
	.dbline 151
; 			 	wr_inc_data2DS1307(addr_date, 1, 31);
	ldi R24,31
	std y+0,R24
	ldi R18,1
	ldi R16,4
	rcall _wr_inc_data2DS1307
	.dbline 152
; 			}
L72:
	.dbline 153
; 			if(menu_st == set_day)
	lds R24,_menu_st
	cpi R24,5
	brne L74
	.dbline 154
; 			{
	.dbline 155
; 			 	wr_inc_data2DS1307(addr_day, 1, 7);
	ldi R24,7
	std y+0,R24
	ldi R18,1
	ldi R16,3
	rcall _wr_inc_data2DS1307
	.dbline 156
; 			}
L74:
	.dbline 157
; 			if(menu_st == set_mons)
	lds R24,_menu_st
	cpi R24,6
	brne L76
	.dbline 158
; 			{
	.dbline 159
; 			 	wr_inc_data2DS1307(addr_mons, 1, 12);
	ldi R24,12
	std y+0,R24
	ldi R18,1
	ldi R16,5
	rcall _wr_inc_data2DS1307
	.dbline 160
; 			}
L76:
	.dbline 161
; 			if(menu_st == set_years)
	lds R24,_menu_st
	cpi R24,7
	brne L78
	.dbline 162
; 			{
	.dbline 163
; 			 	wr_inc_data2DS1307(addr_years, 9, 29);
	ldi R24,29
	std y+0,R24
	ldi R18,9
	ldi R16,6
	rcall _wr_inc_data2DS1307
	.dbline 164
; 			}
L78:
	.dbline 165
; 			update_time();
	rcall _update_time
	.dbline 166
; 		}
L63:
	.dbline 167
; 		if(st_but[s_st_but - 1] == 4)//    -> 
	ldi R24,<_st_but-1
	ldi R25,>_st_but-1
	lds R30,_s_st_but
	clr R31
	add R30,R24
	adc R31,R25
	ldd R24,z+0
	cpi R24,4
	brne L80
	.dbline 168
; 		{
	.dbline 169
; 		 	exit_sets();
	rcall _exit_sets
	.dbline 170
; 			return;
	rjmp L17
L80:
	.dbline 172
; 		}
; 	}
L42:
	.dbline 173
; 	if(st_but[0] == 2)//  
	lds R24,_st_but
	cpi R24,2
	breq X4
	rjmp L83
X4:
	.dbline 174
; 	{
	.dbline 175
; 	 	if(temp_j > 6)
	ldi R24,6
	cp R24,R20
	brsh L85
	.dbline 176
; 		{
	.dbline 177
; 		 	exit_sets();
	rcall _exit_sets
	.dbline 178
; 			return;
	rjmp L17
L85:
	.dbline 180
; 		}
; 	 	menu_st = temp_j + set_years;
	mov R24,R20
	subi R24,249    ; addi 7
	sts _menu_st,R24
	.dbline 181
; 		if(st_but[s_st_but - 1] == 1)//    -> 
	ldi R24,<_st_but-1
	ldi R25,>_st_but-1
	lds R30,_s_st_but
	clr R31
	add R30,R24
	adc R31,R25
	ldd R24,z+0
	cpi R24,1
	brne L87
	.dbline 182
; 		{
	.dbline 183
; 		 	exit_sets();
	rcall _exit_sets
	.dbline 184
; 			return;
	rjmp L17
L87:
	.dbline 186
; 		}
; 		update_alarm_1();
	rcall _update_alarm_1
	.dbline 187
; 		if(st_but[s_st_but - 1] == 3)//   
	ldi R24,<_st_but-1
	ldi R25,>_st_but-1
	lds R30,_s_st_but
	clr R31
	add R30,R24
	adc R31,R25
	ldd R24,z+0
	cpi R24,3
	breq X5
	rjmp L90
X5:
	.dbline 188
; 		{
	.dbline 189
; 		 	s_st_but--;
	lds R24,_s_st_but
	subi R24,1
	sts _s_st_but,R24
	.dbline 190
; 			if(menu_st == set_alarm_type)
	lds R24,_menu_st
	cpi R24,9
	brne L93
	.dbline 191
; 			{
	.dbline 192
; 			 	if(type_alarm == alarm_type_off) type_alarm = alarm_type_sin;
	lds R2,_type_alarm
	tst R2
	brne L95
	.dbline 192
	ldi R24,4
	sts _type_alarm,R24
	rjmp L96
L95:
	.dbline 193
; 				else type_alarm--;
	lds R24,_type_alarm
	subi R24,1
	sts _type_alarm,R24
L96:
	.dbline 194
; 			}
L93:
	.dbline 195
; 			if(menu_st == set_alarm_hours)
	lds R24,_menu_st
	cpi R24,10
	brne L97
	.dbline 196
; 			{
	.dbline 197
; 			 	if(al_hour == 0) al_hour = 23;
	lds R2,_al_hour
	tst R2
	brne L99
	.dbline 197
	ldi R24,23
	sts _al_hour,R24
	rjmp L100
L99:
	.dbline 198
; 				else al_hour--;
	lds R24,_al_hour
	subi R24,1
	sts _al_hour,R24
L100:
	.dbline 199
; 			}
L97:
	.dbline 200
; 			if(menu_st == set_alarm_mins)
	lds R24,_menu_st
	cpi R24,11
	brne L101
	.dbline 201
; 			{
	.dbline 202
; 			 	if(al_min == 0) al_min = 59;
	lds R2,_al_min
	tst R2
	brne L103
	.dbline 202
	ldi R24,59
	sts _al_min,R24
	rjmp L104
L103:
	.dbline 203
; 				else al_min--;
	lds R24,_al_min
	subi R24,1
	sts _al_min,R24
L104:
	.dbline 204
; 			}
L101:
	.dbline 205
; 			if(menu_st == set_alarm_date)
	lds R24,_menu_st
	cpi R24,12
	brne L105
	.dbline 206
; 			{
	.dbline 207
; 			 	if(al_date == 1) al_date = 31;
	lds R24,_al_date
	cpi R24,1
	brne L107
	.dbline 207
	ldi R24,31
	sts _al_date,R24
	rjmp L108
L107:
	.dbline 208
; 				else al_date--;
	lds R24,_al_date
	subi R24,1
	sts _al_date,R24
L108:
	.dbline 209
; 			}
L105:
	.dbline 210
; 			if(menu_st == set_alarm_mons)
	lds R24,_menu_st
	cpi R24,13
	brne L109
	.dbline 211
; 			{
	.dbline 212
; 			 	if(al_mon == 1) al_mon = 12;
	lds R24,_al_mon
	cpi R24,1
	brne L111
	.dbline 212
	ldi R24,12
	sts _al_mon,R24
	rjmp L112
L111:
	.dbline 213
; 				else al_mon--;
	lds R24,_al_mon
	subi R24,1
	sts _al_mon,R24
L112:
	.dbline 214
; 			}
L109:
	.dbline 215
; 			update_alarm_2();
	rcall _update_alarm_2
	.dbline 216
; 			if(menu_st == set_alarm_num)
	lds R24,_menu_st
	cpi R24,8
	brne L113
	.dbline 217
; 			{
	.dbline 218
; 			 	if(num_alarm == 0) num_alarm = 15;
	lds R2,_num_alarm
	tst R2
	brne L115
	.dbline 218
	ldi R24,15
	sts _num_alarm,R24
	rjmp L116
L115:
	.dbline 219
; 				else num_alarm--;
	lds R24,_num_alarm
	subi R24,1
	sts _num_alarm,R24
L116:
	.dbline 220
; 			}
L113:
	.dbline 221
; 		}
L90:
	.dbline 222
; 		if(st_but[s_st_but - 1] == 4)//   
	ldi R24,<_st_but-1
	ldi R25,>_st_but-1
	lds R30,_s_st_but
	clr R31
	add R30,R24
	adc R31,R25
	ldd R24,z+0
	cpi R24,4
	breq X6
	rjmp L117
X6:
	.dbline 223
; 		{
	.dbline 224
; 		 	s_st_but--;
	lds R24,_s_st_but
	subi R24,1
	sts _s_st_but,R24
	.dbline 225
; 			if(menu_st == set_alarm_type)
	lds R24,_menu_st
	cpi R24,9
	brne L120
	.dbline 226
; 			{
	.dbline 227
; 			 	if(type_alarm == alarm_type_sin) type_alarm = alarm_type_off;
	lds R24,_type_alarm
	cpi R24,4
	brne L122
	.dbline 227
	clr R2
	sts _type_alarm,R2
	rjmp L123
L122:
	.dbline 228
; 				else type_alarm++;
	lds R24,_type_alarm
	subi R24,255    ; addi 1
	sts _type_alarm,R24
L123:
	.dbline 229
; 			}
L120:
	.dbline 230
; 			if(menu_st == set_alarm_hours)
	lds R24,_menu_st
	cpi R24,10
	brne L124
	.dbline 231
; 			{
	.dbline 232
; 			 	if(al_hour == 23) al_hour = 0;
	lds R24,_al_hour
	cpi R24,23
	brne L126
	.dbline 232
	clr R2
	sts _al_hour,R2
	rjmp L127
L126:
	.dbline 233
; 				else al_hour++;
	lds R24,_al_hour
	subi R24,255    ; addi 1
	sts _al_hour,R24
L127:
	.dbline 234
; 			}
L124:
	.dbline 235
; 			if(menu_st == set_alarm_mins)
	lds R24,_menu_st
	cpi R24,11
	brne L128
	.dbline 236
; 			{
	.dbline 237
; 			 	if(al_min == 59) al_min = 0;
	lds R24,_al_min
	cpi R24,59
	brne L130
	.dbline 237
	clr R2
	sts _al_min,R2
	rjmp L131
L130:
	.dbline 238
; 				else al_min++;
	lds R24,_al_min
	subi R24,255    ; addi 1
	sts _al_min,R24
L131:
	.dbline 239
; 			}
L128:
	.dbline 240
; 			if(menu_st == set_alarm_date)
	lds R24,_menu_st
	cpi R24,12
	brne L132
	.dbline 241
; 			{
	.dbline 242
; 			 	if(al_date == 31) al_date = 1;
	lds R24,_al_date
	cpi R24,31
	brne L134
	.dbline 242
	ldi R24,1
	sts _al_date,R24
	rjmp L135
L134:
	.dbline 243
; 				else al_date++;
	lds R24,_al_date
	subi R24,255    ; addi 1
	sts _al_date,R24
L135:
	.dbline 244
; 			}
L132:
	.dbline 245
; 			if(menu_st == set_alarm_mons)
	lds R24,_menu_st
	cpi R24,13
	brne L136
	.dbline 246
; 			{
	.dbline 247
; 			 	if(al_mon == 12) al_mon = 1;
	lds R24,_al_mon
	cpi R24,12
	brne L138
	.dbline 247
	ldi R24,1
	sts _al_mon,R24
	rjmp L139
L138:
	.dbline 248
; 				else al_mon++;
	lds R24,_al_mon
	subi R24,255    ; addi 1
	sts _al_mon,R24
L139:
	.dbline 249
; 			}
L136:
	.dbline 250
; 			update_alarm_2();
	rcall _update_alarm_2
	.dbline 251
; 			if(menu_st == set_alarm_num)
	lds R24,_menu_st
	cpi R24,8
	brne L140
	.dbline 252
; 			{
	.dbline 253
; 			 	if(num_alarm == 15) num_alarm = 0;
	lds R24,_num_alarm
	cpi R24,15
	brne L142
	.dbline 253
	clr R2
	sts _num_alarm,R2
	rjmp L143
L142:
	.dbline 254
; 				else num_alarm++;
	lds R24,_num_alarm
	subi R24,255    ; addi 1
	sts _num_alarm,R24
L143:
	.dbline 255
; 			}
L140:
	.dbline 256
; 		}
L117:
	.dbline 257
; 	}
L83:
	.dbline 258
; 	if(st_but[0] == 3)
	lds R24,_st_but
	cpi R24,3
	brne L144
	.dbline 259
; 	{
	.dbline 260
; 		if(view == max_view) view = 0;
	lds R24,_view
	cpi R24,3
	brne L146
	.dbline 260
	clr R2
	sts _view,R2
	rjmp L147
L146:
	.dbline 261
; 		else view++;
	lds R24,_view
	subi R24,255    ; addi 1
	sts _view,R24
L147:
	.dbline 262
; 		EEPROM_WRITE((int)&EE_view, view);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_view
	ldi R19,>_view
	ldi R16,<_EE_view
	ldi R17,>_EE_view
	rcall _EEPROMWriteBytes
	.dbline 263
; 		exit_sets();
	rcall _exit_sets
	.dbline 264
; 	}
L144:
	.dbline 265
; 	if(st_but[0] == 4)
	lds R24,_st_but
	cpi R24,4
	brne L148
	.dbline 266
; 	{
	.dbline 267
; 	 	if(!f_disp_off) f_disp_off = 0x01;//    ->  
	lds R2,_f_disp_off
	tst R2
	brne L150
	.dbline 267
	ldi R24,1
	sts _f_disp_off,R24
	rjmp L151
L150:
	.dbline 268
; 		else if(f_disp_off == 0x01) f_disp_off = 0x03;//   ->  
	lds R24,_f_disp_off
	cpi R24,1
	brne L152
	.dbline 268
	ldi R24,3
	sts _f_disp_off,R24
	rjmp L153
L152:
	.dbline 269
; 			 else if(f_disp_off == 0x03) f_disp_off = 0x02;//   ->  
	lds R24,_f_disp_off
	cpi R24,3
	brne L154
	.dbline 269
	ldi R24,2
	sts _f_disp_off,R24
	rjmp L155
L154:
	.dbline 270
; 			 	  else if(f_disp_off = 0x02) f_disp_off = 0x00;//    ->  
	ldi R24,2
	sts _f_disp_off,R24
	tst R24
	breq L156
	.dbline 270
	clr R2
	sts _f_disp_off,R2
L156:
L155:
L153:
L151:
	.dbline 271
	rcall _exit_sets
	.dbline 272
L148:
	.dbline -2
L17:
	adiw R28,2
	rcall pop_gset3
	.dbline 0 ; func end
	ret
	.dbsym r temp_k 10 c
	.dbsym r temp_i 22 c
	.dbsym r temp_j 20 c
	.dbend
	.dbfunc e exit_sets _exit_sets fV
	.even
_exit_sets::
	.dbline -1
	.dbline 276
; 		exit_sets();
; 	}
; }
; 
; void exit_sets(void)
; {
	.dbline 277
;  	s_st_but = 0;
	clr R2
	sts _s_st_but,R2
	.dbline 278
; 	menu_st = set_none;
	sts _menu_st,R2
	.dbline 279
; 	flags &= 0xFD;
	lds R24,_flags
	andi R24,253
	sts _flags,R24
	.dbline -2
L158:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e wr_dec_data2DS1307 _wr_dec_data2DS1307 fV
;         temp_k -> R10
;         temp_j -> R12
;         temp_i -> R22
;        max_val -> y+10
;        min_val -> R14
;           addr -> R20
	.even
_wr_dec_data2DS1307::
	rcall push_gset5
	mov R14,R18
	mov R20,R16
	.dbline -1
	.dbline 283
; }
; 
; void wr_dec_data2DS1307(unsigned char addr, unsigned char min_val, unsigned char max_val)
; {
	.dbline 284
;  	unsigned char temp_i = 0, temp_j = 0, temp_k = 0;
	clr R22
	.dbline 284
	clr R12
	.dbline 284
	clr R10
	.dbline 285
; 	temp_i = RE_DS1307(addr);
	mov R16,R20
	rcall _RE_DS1307
	mov R22,R16
	.dbline 286
; 	temp_j = (temp_i >> 4) * 10;
	mov R24,R22
	swap R24
	andi R24,#0x0F
	ldi R25,10
	mul R25,R24
	mov R12,R0
	.dbline 287
; 	temp_k = (temp_i&0x0F);
	mov R24,R22
	andi R24,15
	mov R10,R24
	.dbline 288
; 	temp_i = temp_k + temp_j;
	mov R22,R24
	add R22,R0
	.dbline 289
; 	if(temp_i == min_val) temp_i = max_val;
	cp R22,R14
	brne L160
	.dbline 289
	ldd R22,y+10
	rjmp L161
L160:
	.dbline 290
; 	else temp_i--;
	dec R22
L161:
	.dbline 291
; 	temp_j = (temp_i / 10) << 4;
	ldi R17,10
	mov R16,R22
	rcall div8u
	mov R24,R16
	andi R24,#0x0F
	swap R24
	mov R12,R24
	.dbline 292
; 	temp_k = temp_i - ((temp_i / 10) * 10);
	ldi R17,10
	mov R16,R22
	rcall div8u
	ldi R24,10
	mul R24,R16
	mov R10,R22
	sub R10,R0
	.dbline 293
; 	temp_i = temp_j | temp_k;
	mov R22,R12
	or R22,R10
	.dbline 294
; 	WR_DS1307(addr, temp_i);
	mov R18,R22
	mov R16,R20
	rcall _WR_DS1307
	.dbline -2
L159:
	rcall pop_gset5
	.dbline 0 ; func end
	ret
	.dbsym r temp_k 10 c
	.dbsym r temp_j 12 c
	.dbsym r temp_i 22 c
	.dbsym l max_val 10 c
	.dbsym r min_val 14 c
	.dbsym r addr 20 c
	.dbend
	.dbfunc e wr_inc_data2DS1307 _wr_inc_data2DS1307 fV
;         temp_k -> R10
;         temp_j -> R12
;         temp_i -> R22
;        max_val -> y+10
;        min_val -> R14
;           addr -> R20
	.even
_wr_inc_data2DS1307::
	rcall push_gset5
	mov R14,R18
	mov R20,R16
	.dbline -1
	.dbline 298
; }
; 
; void wr_inc_data2DS1307(unsigned char addr, unsigned char min_val, unsigned char max_val)
; {
	.dbline 299
;  	unsigned char temp_i = 0, temp_j = 0, temp_k = 0;
	clr R22
	.dbline 299
	clr R12
	.dbline 299
	clr R10
	.dbline 300
; 	temp_i = RE_DS1307(addr);
	mov R16,R20
	rcall _RE_DS1307
	mov R22,R16
	.dbline 301
; 	temp_j = (temp_i >> 4) * 10;
	mov R24,R22
	swap R24
	andi R24,#0x0F
	ldi R25,10
	mul R25,R24
	mov R12,R0
	.dbline 302
; 	temp_k = (temp_i&0x0F);
	mov R24,R22
	andi R24,15
	mov R10,R24
	.dbline 303
; 	temp_i = temp_k + temp_j;
	mov R22,R24
	add R22,R0
	.dbline 304
; 	if(temp_i == max_val) temp_i = min_val;
	ldd R0,y+10
	cp R22,R0
	brne L163
	.dbline 304
	mov R22,R14
	rjmp L164
L163:
	.dbline 305
; 	else temp_i++;
	inc R22
L164:
	.dbline 306
; 	temp_j = (temp_i / 10) << 4;
	ldi R17,10
	mov R16,R22
	rcall div8u
	mov R24,R16
	andi R24,#0x0F
	swap R24
	mov R12,R24
	.dbline 307
; 	temp_k = temp_i - ((temp_i / 10) * 10);
	ldi R17,10
	mov R16,R22
	rcall div8u
	ldi R24,10
	mul R24,R16
	mov R10,R22
	sub R10,R0
	.dbline 308
; 	temp_i = temp_j | temp_k;
	mov R22,R12
	or R22,R10
	.dbline 309
; 	WR_DS1307(addr, temp_i);
	mov R18,R22
	mov R16,R20
	rcall _WR_DS1307
	.dbline -2
L162:
	rcall pop_gset5
	.dbline 0 ; func end
	ret
	.dbsym r temp_k 10 c
	.dbsym r temp_j 12 c
	.dbsym r temp_i 22 c
	.dbsym l max_val 10 c
	.dbsym r min_val 14 c
	.dbsym r addr 20 c
	.dbend
	.dbfunc e update_alarm_1 _update_alarm_1 fV
	.even
_update_alarm_1::
	.dbline -1
	.dbline 313
; }
; 				
; void update_alarm_1(void)//     
; {
	.dbline 314
; 	al_mon = mas_mon_alarm[num_alarm];
	ldi R24,<_mas_mon_alarm
	ldi R25,>_mas_mon_alarm
	lds R30,_num_alarm
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	sts _al_mon,R2
	.dbline 315
; 	al_date = mas_date_alarm[num_alarm];
	ldi R24,<_mas_date_alarm
	ldi R25,>_mas_date_alarm
	lds R30,_num_alarm
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	sts _al_date,R2
	.dbline 316
; 	al_hour = mas_hour_alarm[num_alarm];
	ldi R24,<_mas_hour_alarm
	ldi R25,>_mas_hour_alarm
	lds R30,_num_alarm
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	sts _al_hour,R2
	.dbline 317
; 	al_min = mas_min_alarm[num_alarm];
	ldi R24,<_mas_min_alarm
	ldi R25,>_mas_min_alarm
	lds R30,_num_alarm
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	sts _al_min,R2
	.dbline 318
; 	type_alarm = mas_type_alarm[num_alarm];
	ldi R24,<_mas_type_alarm
	ldi R25,>_mas_type_alarm
	lds R30,_num_alarm
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	sts _type_alarm,R2
	.dbline -2
L165:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e update_alarm_2 _update_alarm_2 fV
	.even
_update_alarm_2::
	sbiw R28,2
	.dbline -1
	.dbline 322
; }
; 
; void update_alarm_2(void)//  
; {
	.dbline 324
; //-------------       EEPROM------------
; 	mas_mon_alarm[num_alarm] = al_mon;
	ldi R24,<_mas_mon_alarm
	ldi R25,>_mas_mon_alarm
	lds R30,_num_alarm
	clr R31
	add R30,R24
	adc R31,R25
	lds R2,_al_mon
	std z+0,R2
	.dbline 325
; 	mas_date_alarm[num_alarm] = al_date;
	ldi R24,<_mas_date_alarm
	ldi R25,>_mas_date_alarm
	lds R30,_num_alarm
	clr R31
	add R30,R24
	adc R31,R25
	lds R2,_al_date
	std z+0,R2
	.dbline 326
; 	mas_hour_alarm[num_alarm] = al_hour;
	ldi R24,<_mas_hour_alarm
	ldi R25,>_mas_hour_alarm
	lds R30,_num_alarm
	clr R31
	add R30,R24
	adc R31,R25
	lds R2,_al_hour
	std z+0,R2
	.dbline 327
; 	mas_min_alarm[num_alarm] = al_min;
	ldi R24,<_mas_min_alarm
	ldi R25,>_mas_min_alarm
	lds R30,_num_alarm
	clr R31
	add R30,R24
	adc R31,R25
	lds R2,_al_min
	std z+0,R2
	.dbline 328
; 	mas_type_alarm[num_alarm] = type_alarm;
	ldi R24,<_mas_type_alarm
	ldi R25,>_mas_type_alarm
	lds R30,_num_alarm
	clr R31
	add R30,R24
	adc R31,R25
	lds R2,_type_alarm
	std z+0,R2
	.dbline 329
; 	EEPROM_WRITE((int)&EE_mon_alarm[num_alarm], al_mon);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_al_mon
	ldi R19,>_al_mon
	ldi R24,<_EE_mon_alarm
	ldi R25,>_EE_mon_alarm
	lds R16,_num_alarm
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMWriteBytes
	.dbline 330
; 	EEPROM_WRITE((int)&EE_date_alarm[num_alarm], al_date);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_al_date
	ldi R19,>_al_date
	ldi R24,<_EE_date_alarm
	ldi R25,>_EE_date_alarm
	lds R16,_num_alarm
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMWriteBytes
	.dbline 331
; 	EEPROM_WRITE((int)&EE_hour_alarm[num_alarm], al_hour);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_al_hour
	ldi R19,>_al_hour
	ldi R24,<_EE_hour_alarm
	ldi R25,>_EE_hour_alarm
	lds R16,_num_alarm
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMWriteBytes
	.dbline 332
; 	EEPROM_WRITE((int)&EE_min_alarm[num_alarm], al_min);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_al_min
	ldi R19,>_al_min
	ldi R24,<_EE_min_alarm
	ldi R25,>_EE_min_alarm
	lds R16,_num_alarm
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMWriteBytes
	.dbline 333
; 	EEPROM_WRITE((int)&EE_type_alarm[num_alarm], type_alarm);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_type_alarm
	ldi R19,>_type_alarm
	ldi R24,<_EE_type_alarm
	ldi R25,>_EE_type_alarm
	lds R16,_num_alarm
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMWriteBytes
	.dbline -2
L166:
	adiw R28,2
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e read_eeprom_data _read_eeprom_data fV
;         temp_i -> R20
	.even
_read_eeprom_data::
	rcall push_gset1
	sbiw R28,2
	.dbline -1
	.dbline 338
; //-------------       EEPROM------------
; }
; 
; void read_eeprom_data()
; {
	.dbline 339
;  	unsigned char temp_i = 0;
	clr R20
	.dbline 341
; //----------------------------------  EEPROM--------------------------------
; 	EEPROM_READ((int)&EE_len_alarm, len_alarm);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_len_alarm
	ldi R19,>_len_alarm
	ldi R16,<_EE_len_alarm
	ldi R17,>_EE_len_alarm
	rcall _EEPROMReadBytes
	.dbline 342
; 	EEPROM_READ((int)&EE_view, view);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_view
	ldi R19,>_view
	ldi R16,<_EE_view
	ldi R17,>_EE_view
	rcall _EEPROMReadBytes
	.dbline 343
; 	for(temp_i = 0; temp_i < 16; temp_i++)
	rjmp L171
L168:
	.dbline 344
	.dbline 345
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R24,<_mas_type_alarm
	ldi R25,>_mas_type_alarm
	mov R18,R20
	clr R19
	add R18,R24
	adc R19,R25
	ldi R24,<_EE_type_alarm
	ldi R25,>_EE_type_alarm
	mov R16,R20
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMReadBytes
	.dbline 346
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R24,<_mas_hour_alarm
	ldi R25,>_mas_hour_alarm
	mov R18,R20
	clr R19
	add R18,R24
	adc R19,R25
	ldi R24,<_EE_hour_alarm
	ldi R25,>_EE_hour_alarm
	mov R16,R20
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMReadBytes
	.dbline 347
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R24,<_mas_min_alarm
	ldi R25,>_mas_min_alarm
	mov R18,R20
	clr R19
	add R18,R24
	adc R19,R25
	ldi R24,<_EE_min_alarm
	ldi R25,>_EE_min_alarm
	mov R16,R20
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMReadBytes
	.dbline 348
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R24,<_mas_date_alarm
	ldi R25,>_mas_date_alarm
	mov R18,R20
	clr R19
	add R18,R24
	adc R19,R25
	ldi R24,<_EE_date_alarm
	ldi R25,>_EE_date_alarm
	mov R16,R20
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMReadBytes
	.dbline 349
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R24,<_mas_mon_alarm
	ldi R25,>_mas_mon_alarm
	mov R18,R20
	clr R19
	add R18,R24
	adc R19,R25
	ldi R24,<_EE_mon_alarm
	ldi R25,>_EE_mon_alarm
	mov R16,R20
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMReadBytes
	.dbline 350
L169:
	.dbline 343
	inc R20
L171:
	.dbline 343
	cpi R20,16
	brsh X7
	rjmp L168
X7:
	.dbline -2
L167:
	adiw R28,2
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r temp_i 20 c
	.dbend
