#include <iom8v.h>
#include <macros.h>
#include "SPI_MAX7221.h"
#include "var.h"

unsigned int ADC_val(void);

unsigned int ADC_val(void)
{
 	unsigned int adc;
	ADMUX = 0;
	adc = ADCL;// ADCL
	adc = ADCH;// ADCH
	adc = 0;
	CLI();//  
 	ADMUX = 0xC0;
 	ADCSRA = 0xCF;// 
	while(ADCSRA&0x40) WDR();
	adc |= ADCL;
	adc |= (((unsigned int)ADCH)<<8);
	ADCSRA = 0;
	ADMUX = 0;
	SEI();// 
	return adc;
}

void set_intensity(void)
{
 	unsigned int temp_i = 0;
	unsigned char temp_j = 0;
	temp_i = ADC_val();
	if(temp_i > 100)
	{
	 	temp_j = 15 - (temp_i / 25);
		if((temp_i / 25) > 15) temp_j = 0x00;
	}
	else temp_j = 0x0F;
	wr_int2max(0x0A, temp_j);// 
	intensity = temp_j;
}