	.module photo.c
	.area text(rom, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\photo.c
	.dbfunc e ADC_val _ADC_val fi
;            adc -> R16,R17
	.even
_ADC_val::
	.dbline -1
	.dbline 9
; #include <iom8v.h>
; #include <macros.h>
; #include "SPI_MAX7221.h"
; #include "var.h"
; 
; unsigned int ADC_val(void);
; 
; unsigned int ADC_val(void)
; {
	.dbline 11
;  	unsigned int adc;
; 	ADMUX = 0;
	clr R2
	out 0x7,R2
	.dbline 12
; 	adc = ADCL;// ADCL
	in R16,0x4
	clr R17
	.dbline 13
; 	adc = ADCH;// ADCH
	in R16,0x5
	clr R17
	.dbline 14
; 	adc = 0;
	clr R16
	.dbline 15
; 	CLI();//  
	cli
	.dbline 16
;  	ADMUX = 0xC0;
	ldi R24,192
	out 0x7,R24
	.dbline 17
;  	ADCSRA = 0xCF;// 
	ldi R24,207
	out 0x6,R24
	rjmp L3
L2:
	.dbline 18
	wdr
L3:
	.dbline 18
; 	while(ADCSRA&0x40) WDR();
	sbic 0x6,6
	rjmp L2
	.dbline 19
; 	adc |= ADCL;
	in R2,0x4
	clr R3
	or R16,R2
	or R17,R3
	.dbline 20
; 	adc |= (((unsigned int)ADCH)<<8);
	in R2,0x5
	clr R3
	mov R3,R2
	clr R2
	or R16,R2
	or R17,R3
	.dbline 21
; 	ADCSRA = 0;
	clr R2
	out 0x6,R2
	.dbline 22
; 	ADMUX = 0;
	out 0x7,R2
	.dbline 23
; 	SEI();// 
	sei
	.dbline 24
; 	return adc;
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym r adc 16 i
	.dbend
	.dbfunc e set_intensity _set_intensity fV
;         temp_i -> R22,R23
;         temp_j -> R20
	.even
_set_intensity::
	rcall push_gset2
	.dbline -1
	.dbline 28
; }
; 
; void set_intensity(void)
; {
	.dbline 29
;  	unsigned int temp_i = 0;
	clr R22
	clr R23
	.dbline 30
; 	unsigned char temp_j = 0;
	clr R20
	.dbline 31
; 	temp_i = ADC_val();
	rcall _ADC_val
	movw R22,R16
	.dbline 32
; 	if(temp_i > 100)
	ldi R24,100
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brsh L6
	.dbline 33
; 	{
	.dbline 34
; 	 	temp_j = 15 - (temp_i / 25);
	ldi R18,25
	ldi R19,0
	rcall div16u
	ldi R20,15
	sub R20,R16
	sbc R21,R17
	.dbline 35
; 		if((temp_i / 25) > 15) temp_j = 0x00;
	ldi R18,25
	ldi R19,0
	movw R16,R22
	rcall div16u
	ldi R24,15
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brsh L7
	.dbline 35
	clr R20
	.dbline 36
; 	}
	rjmp L7
L6:
	.dbline 37
; 	else temp_j = 0x0F;
	ldi R20,15
L7:
	.dbline 38
; 	wr_int2max(0x0A, temp_j);// 
	mov R18,R20
	ldi R16,10
	rcall _wr_int2max
	.dbline 39
; 	intensity = temp_j;
	sts _intensity,R20
	.dbline -2
L5:
	rcall pop_gset2
	.dbline 0 ; func end
	ret
	.dbsym r temp_i 22 i
	.dbsym r temp_j 20 c
	.dbend
