	.module TWI_DS1307.c
	.area text(rom, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\TWI_DS1307.c
	.dbfunc e twi_init _twi_init fV
	.even
_twi_init::
	.dbline -1
	.dbline 15
; #include <iom8v.h>
; #include <macros.h>
; #include "var.h"
; 
; void twi_init(void);// TWI
; void WR_DS1307(unsigned char address, unsigned char wr_data);//    DS1307
; unsigned char RE_DS1307(unsigned char address);//    DS1307
; //void WR_DS1307_MAS(unsigned char address, unsigned char *array, unsigned char size);//    DS1307
; void RE_DS1307_MAS(unsigned char address, unsigned char *array, unsigned char size);//    DS1307
; void update_time(void);
; 
; //TWI initialize
; // bit rate:0
; void twi_init(void)// TWI
; {
	.dbline 16
;  TWCR= 0X00;
	clr R2
	out 0x36,R2
	.dbline 17
;  TWBR= 0x08;
	ldi R24,8
	out 0x0,R24
	.dbline 18
;  TWSR= 0x02;
	ldi R24,2
	out 0x1,R24
	.dbline 19
;  TWAR= 0x00;
	out 0x2,R2
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e WR_DS1307 _WR_DS1307 fV
;        wr_data -> R20
;        address -> R22
	.even
_WR_DS1307::
	rcall push_gset2
	mov R20,R18
	mov R22,R16
	.dbline -1
	.dbline 22
; }
; 
; void WR_DS1307(unsigned char address, unsigned char wr_data){
	.dbline 23
; 	twi_init();
	rcall _twi_init
	.dbline 24
; 	CLI(); //disable all interrupts
	cli
	.dbline 25
; 	TWCR = 0xE4;//
	ldi R24,228
	out 0x36,R24
	rjmp L4
L3:
	.dbline 26
; 	while(1) if((TWCR&0x80)&&((TWSR&0xFC) == 0x08)) break;// 
	in R2,0x36
	sbrs R2,7
	rjmp L6
	in R24,0x1
	andi R24,252
	cpi R24,8
	brne L6
	.dbline 26
	rjmp L5
L6:
L4:
	.dbline 26
	rjmp L3
L5:
	.dbline 27
; 	TWDR = 0xD0;//SLA+W
	ldi R24,208
	out 0x3,R24
	.dbline 28
; 	TWCR = 0xC4;//  " "
	ldi R24,196
	out 0x36,R24
	rjmp L9
L8:
	.dbline 29
; 	while(1){
	.dbline 30
; 		if((TWCR&0x80)&&((TWSR&0xFC) == 0x18)){
	in R2,0x36
	sbrs R2,7
	rjmp L11
	in R24,0x1
	andi R24,252
	cpi R24,24
	brne L11
	.dbline 30
	.dbline 31
; 			break;//   SLA+W   
	rjmp L10
L11:
	.dbline 33
L9:
	.dbline 29
	rjmp L8
L10:
	.dbline 34
; 		}
; 	}
; 	TWDR = address;// 
	out 0x3,R22
	.dbline 35
; 	TWCR = 0xC4;// 
	ldi R24,196
	out 0x36,R24
	rjmp L14
L13:
	.dbline 36
; 	while(1){
	.dbline 37
; 		if((TWCR&0x80)&&((TWSR&0xFC) == 0x28)){
	in R2,0x36
	sbrs R2,7
	rjmp L16
	in R24,0x1
	andi R24,252
	cpi R24,40
	brne L16
	.dbline 37
	.dbline 38
; 			break;//      
	rjmp L15
L16:
	.dbline 40
L14:
	.dbline 36
	rjmp L13
L15:
	.dbline 41
; 		}
; 	}
; 	TWDR = wr_data;// 
	out 0x3,R20
	.dbline 42
; 	TWCR = 0xC4;// 
	ldi R24,196
	out 0x36,R24
	rjmp L19
L18:
	.dbline 43
; 	while(1){
	.dbline 44
; 		if((TWCR&0x80)&&((TWSR&0xFC) == 0x28)){
	in R2,0x36
	sbrs R2,7
	rjmp L21
	in R24,0x1
	andi R24,252
	cpi R24,40
	brne L21
	.dbline 44
	.dbline 45
; 			break;//      
	rjmp L20
L21:
	.dbline 47
L19:
	.dbline 43
	rjmp L18
L20:
	.dbline 48
; 		}
; 	}
; 	TWCR = 0xD4;//
	ldi R24,212
	out 0x36,R24
	.dbline 49
; 	SEI(); //re-enable interrupts
	sei
	.dbline -2
L2:
	rcall pop_gset2
	.dbline 0 ; func end
	ret
	.dbsym r wr_data 20 c
	.dbsym r address 22 c
	.dbend
	.dbfunc e RE_DS1307 _RE_DS1307 fc
;      data_TWDR -> R20
;        address -> R20
	.even
_RE_DS1307::
	rcall push_gset1
	mov R20,R16
	.dbline -1
	.dbline 52
; }
; 
; unsigned char RE_DS1307(unsigned char address){
	.dbline 54
; 	unsigned char data_TWDR;
; 	twi_init();
	rcall _twi_init
	.dbline 55
; 	CLI(); //disable all interrupts
	cli
	.dbline 56
; 	TWCR = 0xE4;//
	ldi R24,228
	out 0x36,R24
	rjmp L25
L24:
	.dbline 57
; 	while(1) if((TWCR&0x80)&&((TWSR&0xFC) == 0x08)) break;// 
	in R2,0x36
	sbrs R2,7
	rjmp L27
	in R24,0x1
	andi R24,252
	cpi R24,8
	brne L27
	.dbline 57
	rjmp L26
L27:
L25:
	.dbline 57
	rjmp L24
L26:
	.dbline 58
; 	TWDR = 0xD0;//SLA+W
	ldi R24,208
	out 0x3,R24
	.dbline 59
; 	TWCR = 0xC4;//  " "
	ldi R24,196
	out 0x36,R24
	rjmp L30
L29:
	.dbline 60
; 	while(1){
	.dbline 61
; 		if((TWCR&0x80)&&((TWSR&0xFC) == 0x18)){
	in R2,0x36
	sbrs R2,7
	rjmp L32
	in R24,0x1
	andi R24,252
	cpi R24,24
	brne L32
	.dbline 61
	.dbline 62
; 			break;//   SLA+W   
	rjmp L31
L32:
	.dbline 64
L30:
	.dbline 60
	rjmp L29
L31:
	.dbline 65
; 		}
; 	}
; 	TWDR = address;// 
	out 0x3,R20
	.dbline 66
; 	TWCR = 0xC4;// 
	ldi R24,196
	out 0x36,R24
	rjmp L35
L34:
	.dbline 67
; 	while(1){
	.dbline 68
; 		if((TWCR&0x80)&&((TWSR&0xFC) == 0x28)){
	in R2,0x36
	sbrs R2,7
	rjmp L37
	in R24,0x1
	andi R24,252
	cpi R24,40
	brne L37
	.dbline 68
	.dbline 69
; 			break;//      
	rjmp L36
L37:
	.dbline 71
L35:
	.dbline 67
	rjmp L34
L36:
	.dbline 72
; 		}
; 	}
; 	TWCR = 0xE4;//
	ldi R24,228
	out 0x36,R24
	rjmp L40
L39:
	.dbline 73
; 	while(1) if((TWCR&0x80)&&((TWSR&0xFC) == 0x10)) break;// 
	in R2,0x36
	sbrs R2,7
	rjmp L42
	in R24,0x1
	andi R24,252
	cpi R24,16
	brne L42
	.dbline 73
	rjmp L41
L42:
L40:
	.dbline 73
	rjmp L39
L41:
	.dbline 74
; 	TWDR = 0xD1;//SLA+R
	ldi R24,209
	out 0x3,R24
	.dbline 75
; 	TWCR = 0xC4;//  " "
	ldi R24,196
	out 0x36,R24
	rjmp L45
L44:
	.dbline 76
; 	while(1){
	.dbline 77
; 		if((TWCR&0x80)&&((TWSR&0xFC) == 0x40)){
	in R2,0x36
	sbrs R2,7
	rjmp L47
	in R24,0x1
	andi R24,252
	cpi R24,64
	brne L47
	.dbline 77
	.dbline 78
; 			break;//   SLA+R   
	rjmp L46
L47:
	.dbline 80
L45:
	.dbline 76
	rjmp L44
L46:
	.dbline 81
; 		}
; 	}
; 	TWCR = 0x84;// 
	ldi R24,132
	out 0x36,R24
	rjmp L50
L49:
	.dbline 82
; 	while(1){
	.dbline 83
; 		if((TWCR&0x80)&&((TWSR&0xFC) == 0x58)){
	in R2,0x36
	sbrs R2,7
	rjmp L52
	in R24,0x1
	andi R24,252
	cpi R24,88
	brne L52
	.dbline 83
	.dbline 84
; 			break;//      
	rjmp L51
L52:
	.dbline 86
L50:
	.dbline 82
	rjmp L49
L51:
	.dbline 87
; 		}
; 	}
; 	data_TWDR = TWDR;// 
	in R20,0x3
	.dbline 88
; 	TWCR = 0xD4;//
	ldi R24,212
	out 0x36,R24
	.dbline 89
; 	SEI(); //re-enable interrupts
	sei
	.dbline 90
; 	return data_TWDR;
	mov R16,R20
	.dbline -2
L23:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r data_TWDR 20 c
	.dbsym r address 20 c
	.dbend
	.dbfunc e RE_DS1307_MAS _RE_DS1307_MAS fV
; RE_DS1307_MAS_i -> R20,R21
;           size -> R22
;          array -> R10,R11
;        address -> R12
	.even
_RE_DS1307_MAS::
	rcall push_gset4
	movw R10,R18
	mov R12,R16
	ldd R22,y+8
	.dbline -1
	.dbline 124
; }
; 
; /*void WR_DS1307_MAS(unsigned char address, unsigned char *array, unsigned char size){
; 	unsigned int WR_DS1307_MAS_i = 0;
; 	twi_init();
; 	TWCR = 0xE4;//
; 	while(1) if((TWCR&0x80)&&((TWSR&0xFC) == 0x08)) break;// 
; 	TWDR = 0xD0;//SLA+W
; 	TWCR = 0xC4;//  " "
; 	while(1){
; 		if((TWCR&0x80)&&((TWSR&0xFC) == 0x18)){
; 			break;//   SLA+W   
; 		}
; 	}
; 	TWDR = address;//  (8  )
; 	TWCR = 0xC4;// 
; 	while(1){
; 		if((TWCR&0x80)&&((TWSR&0xFC) == 0x28)){
; 			break;//      
; 		}
; 	}
; 	for(WR_DS1307_MAS_i = 0; WR_DS1307_MAS_i < size; WR_DS1307_MAS_i++){
; 		TWDR = array[WR_DS1307_MAS_i];// 
; 		TWCR = 0xC4;// 
; 		while(1){
; 			if((TWCR&0x80)&&((TWSR&0xFC) == 0x28)){
; 				break;//      
; 			}
; 		}
; 	}
; 	TWCR = 0xD4;//
; }*/
; 
; void RE_DS1307_MAS(unsigned char address, unsigned char *array, unsigned char size){
	.dbline 125
; 	unsigned int RE_DS1307_MAS_i = 0;
	clr R20
	clr R21
	.dbline 126
; 	twi_init();
	rcall _twi_init
	.dbline 127
; 	CLI(); //disable all interrupts
	cli
	.dbline 128
; 	TWCR = 0xE4;//
	ldi R24,228
	out 0x36,R24
	rjmp L56
L55:
	.dbline 130
; 	while(1)
; 	{
	.dbline 131
; 	 	if((TWCR&0x80)&&((TWSR&0xFC) == 0x08)) break;// 
	in R2,0x36
	sbrs R2,7
	rjmp L58
	in R24,0x1
	andi R24,252
	cpi R24,8
	brne L58
	.dbline 131
	rjmp L57
L58:
	.dbline 133
L56:
	.dbline 129
	rjmp L55
L57:
	.dbline 134
; 		//WDR();
; 	}
; 	TWDR = 0xD0;//SLA+W
	ldi R24,208
	out 0x3,R24
	.dbline 135
; 	TWCR = 0xC4;//  " "
	ldi R24,196
	out 0x36,R24
	rjmp L61
L60:
	.dbline 136
; 	while(1){
	.dbline 137
; 		if((TWCR&0x80)&&((TWSR&0xFC) == 0x18)){
	in R2,0x36
	sbrs R2,7
	rjmp L63
	in R24,0x1
	andi R24,252
	cpi R24,24
	brne L63
	.dbline 137
	.dbline 138
; 			break;//   SLA+W   
	rjmp L62
L63:
	.dbline 141
L61:
	.dbline 136
	rjmp L60
L62:
	.dbline 142
; 		}
; 		//WDR();
; 	}
; 	TWDR = address;//  (8  )
	out 0x3,R12
	.dbline 143
; 	TWCR = 0xC4;// 
	ldi R24,196
	out 0x36,R24
	rjmp L66
L65:
	.dbline 144
; 	while(1){
	.dbline 145
; 		if((TWCR&0x80)&&((TWSR&0xFC) == 0x28)){
	in R2,0x36
	sbrs R2,7
	rjmp L68
	in R24,0x1
	andi R24,252
	cpi R24,40
	brne L68
	.dbline 145
	.dbline 146
; 			break;//      
	rjmp L67
L68:
	.dbline 149
L66:
	.dbline 144
	rjmp L65
L67:
	.dbline 150
; 		}
; 		//WDR();
; 	}
; 	TWCR = 0xE4;//
	ldi R24,228
	out 0x36,R24
	rjmp L71
L70:
	.dbline 151
; 	while(1) if((TWCR&0x80)&&((TWSR&0xFC) == 0x10)) break;// 
	in R2,0x36
	sbrs R2,7
	rjmp L73
	in R24,0x1
	andi R24,252
	cpi R24,16
	brne L73
	.dbline 151
	rjmp L72
L73:
L71:
	.dbline 151
	rjmp L70
L72:
	.dbline 152
; 	TWDR = 0xD1;//SLA+R
	ldi R24,209
	out 0x3,R24
	.dbline 153
; 	TWCR = 0xC4;//  " "
	ldi R24,196
	out 0x36,R24
	rjmp L76
L75:
	.dbline 154
; 	while(1){
	.dbline 155
; 		if((TWCR&0x80)&&((TWSR&0xFC) == 0x40)){
	in R2,0x36
	sbrs R2,7
	rjmp L78
	in R24,0x1
	andi R24,252
	cpi R24,64
	brne L78
	.dbline 155
	.dbline 156
; 			break;//   SLA+R   
	rjmp L77
L78:
	.dbline 159
L76:
	.dbline 154
	rjmp L75
L77:
	.dbline 160
	clr R20
	clr R21
	rjmp L83
L80:
	.dbline 160
; 		}
; 		//WDR();
; 	}
; 	for(RE_DS1307_MAS_i = 0; RE_DS1307_MAS_i < size; RE_DS1307_MAS_i++){
	.dbline 161
; 		if(RE_DS1307_MAS_i != (size-1)) TWCR = 0xC4;// 
	mov R24,R22
	clr R25
	sbiw R24,1
	cp R20,R24
	cpc R21,R25
	breq L84
	.dbline 161
	ldi R24,196
	out 0x36,R24
	rjmp L87
L84:
	.dbline 162
; 		else TWCR = 0x84;// 
	ldi R24,132
	out 0x36,R24
	rjmp L87
L86:
	.dbline 163
; 		while(1){
	.dbline 164
; 			if((TWCR&0x80)&&((TWSR&0xFC) == 0x50)&&(RE_DS1307_MAS_i != (size-1))){
	in R2,0x36
	sbrs R2,7
	rjmp L89
	in R24,0x1
	andi R24,252
	cpi R24,80
	brne L89
	mov R24,R22
	clr R25
	sbiw R24,1
	cp R20,R24
	cpc R21,R25
	breq L89
	.dbline 164
	.dbline 165
; 				break;//      
	rjmp L88
L89:
	.dbline 167
; 			}
; 			if((TWCR&0x80)&&((TWSR&0xFC) == 0x58)&&(RE_DS1307_MAS_i == (size-1))){
	in R2,0x36
	sbrs R2,7
	rjmp L91
	in R24,0x1
	andi R24,252
	cpi R24,88
	brne L91
	mov R24,R22
	clr R25
	sbiw R24,1
	cp R20,R24
	cpc R21,R25
	brne L91
	.dbline 167
	.dbline 168
; 				break;//      
	rjmp L88
L91:
	.dbline 171
L87:
	.dbline 163
	rjmp L86
L88:
	.dbline 172
	movw R30,R20
	add R30,R10
	adc R31,R11
	in R2,0x3
	std z+0,R2
	.dbline 173
L81:
	.dbline 160
	subi R20,255  ; offset = 1
	sbci R21,255
L83:
	.dbline 160
	mov R2,R22
	clr R3
	cp R20,R2
	cpc R21,R3
	brsh X0
	rjmp L80
X0:
	.dbline 174
; 			}
; 			//WDR();
; 		}
; 		array[RE_DS1307_MAS_i] = TWDR;// 
; 	}
; 	TWCR = 0xD4;//
	ldi R24,212
	out 0x36,R24
	.dbline 175
; 	SEI(); //re-enable interrupts
	sei
	.dbline -2
L54:
	rcall pop_gset4
	.dbline 0 ; func end
	ret
	.dbsym r RE_DS1307_MAS_i 20 i
	.dbsym r size 22 c
	.dbsym r array 10 pc
	.dbsym r address 12 c
	.dbend
	.dbfunc e update_time _update_time fV
	.even
_update_time::
	sbiw R28,1
	.dbline -1
	.dbline 179
; }
; 
; void update_time(void)
; {
	.dbline 180
;  	RE_DS1307_MAS(0x00, mas_DS1307, 0x07);
	ldi R24,7
	std y+0,R24
	ldi R18,<_mas_DS1307
	ldi R19,>_mas_DS1307
	clr R16
	rcall _RE_DS1307_MAS
	.dbline 182
; 	
; 	year_1 = (mas_DS1307[6] >> 4);
	lds R24,_mas_DS1307+6
	swap R24
	andi R24,#0x0F
	sts _year_1,R24
	.dbline 183
; 	year_2 = (mas_DS1307[6]&0x0F);
	lds R24,_mas_DS1307+6
	andi R24,15
	sts _year_2,R24
	.dbline 186
; 	
; 	
; 	mon_1 = ((mas_DS1307[5]&0x10) >> 4);
	lds R24,_mas_DS1307+5
	andi R24,16
	swap R24
	andi R24,#0x0F
	sts _mon_1,R24
	.dbline 187
; 	mon_2 = (mas_DS1307[5]&0x0F);
	lds R24,_mas_DS1307+5
	andi R24,15
	sts _mon_2,R24
	.dbline 189
; 	
; 	date_1 = ((mas_DS1307[4]&0x30) >> 4);
	lds R24,_mas_DS1307+4
	andi R24,48
	swap R24
	andi R24,#0x0F
	sts _date_1,R24
	.dbline 190
; 	date_2 = (mas_DS1307[4]&0x0F);
	lds R24,_mas_DS1307+4
	andi R24,15
	sts _date_2,R24
	.dbline 192
; 	
; 	day = mas_DS1307[3];
	lds R2,_mas_DS1307+3
	sts _day,R2
	.dbline 194
; 	
; 	hour_1 = ((mas_DS1307[2]&0x30) >> 4);
	lds R24,_mas_DS1307+2
	andi R24,48
	swap R24
	andi R24,#0x0F
	sts _hour_1,R24
	.dbline 195
; 	hour_2 = (mas_DS1307[2]&0x0F);
	lds R24,_mas_DS1307+2
	andi R24,15
	sts _hour_2,R24
	.dbline 197
; 	
; 	min_1 = (mas_DS1307[1] >> 4);
	lds R24,_mas_DS1307+1
	swap R24
	andi R24,#0x0F
	sts _min_1,R24
	.dbline 198
; 	min_2 = (mas_DS1307[1]&0x0F);
	lds R24,_mas_DS1307+1
	andi R24,15
	sts _min_2,R24
	.dbline 200
; 	
; 	sec_1 = ((mas_DS1307[0]&0x70) >> 4);
	lds R24,_mas_DS1307
	andi R24,112
	swap R24
	andi R24,#0x0F
	sts _sec_1,R24
	.dbline 201
; 	sec_2 = (mas_DS1307[0]&0x0F);
	lds R24,_mas_DS1307
	andi R24,15
	sts _sec_2,R24
	.dbline -2
L93:
	adiw R28,1
	.dbline 0 ; func end
	ret
	.dbend
