	.module main.c
	.area text(rom, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\main.c
	.dbfunc e port_init _port_init fV
	.even
_port_init::
	.dbline -1
	.dbline 20
; //ICC-AVR application builder : 25.08.2009 11:12:49
; // Target : M8
; // Crystal: 6.0000Mhz
; 
; #include <iom8v.h>
; #include <macros.h>
; #include <stdlib.h>
; #include "SPI_MAX7221.h"
; #include "TWI_DS1307.h"
; #include "var.h"
; #include "in_out.h"
; #include "photo.h"
; #include "eeprom.h"
; #include "RS232.h"
; #include "TWI_LM76.h"
; 
; unsigned char music(unsigned char first, unsigned char last);
; 
; void port_init(void)
; {
	.dbline 21
;  PORTB = 0x01;
	ldi R24,1
	out 0x18,R24
	.dbline 22
;  DDRB  = 0x29|0x02;
	ldi R24,43
	out 0x17,R24
	.dbline 23
;  PORTC = 0x0E; //m103 output only
	ldi R24,14
	out 0x15,R24
	.dbline 24
;  DDRC  = 0x00;
	clr R2
	out 0x14,R2
	.dbline 25
;  PORTD = 0xE4;
	ldi R24,228
	out 0x12,R24
	.dbline 26
;  DDRD  = 0xC0;
	ldi R24,192
	out 0x11,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e watchdog_init _watchdog_init fV
	.even
_watchdog_init::
	.dbline -1
	.dbline 32
; }
; 
; //Watchdog initialize
; // prescale: 2048K
; void watchdog_init(void)
; {
	.dbline 33
;  	WDR(); //this prevents a timout on enabling
	wdr
	.dbline 34
; 	WDTCR = 0x18;
	ldi R24,24
	out 0x21,R24
	.dbline 35
; 	WDTCR = 0x0F; //WATCHDOG ENABLED - dont forget to issue WDRs
	ldi R24,15
	out 0x21,R24
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e spi_init _spi_init fV
	.even
_spi_init::
	.dbline -1
	.dbline 41
; }
; 
; //SPI initialize
; // clock rate: 921599hz
; void spi_init(void)
; {
	.dbline 42
;  SPCR = 0x00; //setup SPI
	clr R2
	out 0xd,R2
	.dbline 43
;  SPSR = 0x00; //setup SPI
	out 0xe,R2
	.dbline -2
L3:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 2
	rjmp _int0_isr
	.area text(rom, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\main.c
	.dbfunc e int0_isr _int0_isr fV
	.even
_int0_isr::
	rcall push_lset
	rcall push_gset2
	.dbline -1
	.dbline 48
; }
; 
; #pragma interrupt_handler int0_isr:2
; void int0_isr(void)
; {
	.dbline 49
;  	if(!(f_disp_off&0x01)) if(intensity > min_intensity) VDs(1);//   
	lds R2,_f_disp_off
	sbrc R2,0
	rjmp L5
	.dbline 49
	ldi R24,5
	lds R2,_intensity
	cp R24,R2
	brsh L7
	.dbline 49
	ldi R16,1
	rcall _VDs
L7:
L5:
	.dbline 50
; 	dots_count = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	sts _dots_count+1,R21
	sts _dots_count,R20
	sts _dots_count+2+1,R23
	sts _dots_count+2,R22
	.dbline 51
; 	if(!(flags&0x02)) update_time();
	lds R2,_flags
	sbrc R2,1
	rjmp L9
	.dbline 51
	rcall _update_time
L9:
	.dbline 52
; 	flags |= 0x01;//   /
	lds R24,_flags
	ori R24,1
	sts _flags,R24
	.dbline -2
L4:
	rcall pop_gset2
	rcall pop_lset
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e timer1_init _timer1_init fV
	.even
_timer1_init::
	.dbline -1
	.dbline 60
; }
; 
; //TIMER1 initialize - prescale:1
; // WGM: 9) PWM phz freq correct, TOP=OCRnA
; // desired value: 440Hz
; // actual value: 440,012Hz (0,0%)
; void timer1_init(void)
; {
	.dbline 61
;  TCCR1B = 0x00; //stop
	clr R2
	out 0x2e,R2
	.dbline 62
;  TCNT1H = 0x00; //setup
	out 0x2d,R2
	.dbline 63
;  TCNT1L = 0x00;
	out 0x2c,R2
	.dbline 64
;  OCR1AH = 0x0F;
	ldi R24,15
	out 0x2b,R24
	.dbline 65
;  OCR1AL = 0xA2;
	ldi R24,162
	out 0x2a,R24
	.dbline 66
;  OCR1BH = 0x1A;
	ldi R24,26
	out 0x29,R24
	.dbline 67
;  OCR1BL = 0xA2;
	ldi R24,162
	out 0x28,R24
	.dbline 68
;  ICR1H  = 0xA2;
	out 0x27,R24
	.dbline 69
;  ICR1L  = 0x1A;
	ldi R24,26
	out 0x26,R24
	.dbline 70
;  TCCR1A = 0x41;
	ldi R24,65
	out 0x2f,R24
	.dbline 71
;  TCCR1B = 0x00;// 
	out 0x2e,R2
	.dbline -2
L11:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e timer0_init _timer0_init fV
	.even
_timer0_init::
	.dbline -1
	.dbline 79
;  //0x11; //start Timer
; }
; 
; //TIMER0 initialize - prescale:1024
; // desired value: 40mSec
; // actual value: 39,936mSec (0,2%)
; void timer0_init(void)
; {
	.dbline 80
;  TCCR0 = 0x00; //stop
	clr R2
	out 0x33,R2
	.dbline 81
;  TCNT0 = 0x16; //set count
	ldi R24,22
	out 0x32,R24
	.dbline 82
;  TCCR0 = 0x05; //start timer
	ldi R24,5
	out 0x33,R24
	.dbline -2
L12:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 18
	rjmp _timer0_ovf_isr
	.area text(rom, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\main.c
	.dbfunc e timer0_ovf_isr _timer0_ovf_isr fV
	.even
_timer0_ovf_isr::
	st -y,R0
	st -y,R1
	st -y,R2
	st -y,R3
	st -y,R4
	st -y,R5
	st -y,R8
	st -y,R9
	st -y,R16
	st -y,R17
	st -y,R18
	st -y,R19
	st -y,R24
	st -y,R25
	st -y,R30
	in R0,0x3f
	st -y,R0
	rcall push_gset2
	.dbline -1
	.dbline 87
; }
; 
; #pragma interrupt_handler timer0_ovf_isr:10
; void timer0_ovf_isr(void)
; {
	.dbline 88
;  TCNT0 = 0x16; //reload counter value
	ldi R24,22
	out 0x32,R24
	.dbline 89
;  dots_count += d_main_count;
	ldi R20,0
	ldi R21,156
	ldi R22,0
	ldi R23,0
	lds R4,_dots_count+2
	lds R5,_dots_count+2+1
	lds R2,_dots_count
	lds R3,_dots_count+1
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	sts _dots_count+1,R3
	sts _dots_count,R2
	sts _dots_count+2+1,R5
	sts _dots_count+2,R4
	.dbline 90
;  keys_count += d_main_count;
	ldi R20,0
	ldi R21,156
	ldi R22,0
	ldi R23,0
	lds R4,_keys_count+2
	lds R5,_keys_count+2+1
	lds R2,_keys_count
	lds R3,_keys_count+1
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	sts _keys_count+1,R3
	sts _keys_count,R2
	sts _keys_count+2+1,R5
	sts _keys_count+2,R4
	.dbline 91
;  if(f_alarm_on&0x01)
	lds R2,_f_alarm_on
	sbrs R2,0
	rjmp L14
	.dbline 92
;  {
	.dbline 93
;   	alarm_count += d_main_count;
	ldi R20,0
	ldi R21,156
	ldi R22,0
	ldi R23,0
	lds R4,_alarm_count+2
	lds R5,_alarm_count+2+1
	lds R2,_alarm_count
	lds R3,_alarm_count+1
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	sts _alarm_count+1,R3
	sts _alarm_count,R2
	sts _alarm_count+2+1,R5
	sts _alarm_count+2,R4
	.dbline 94
;  	if(alarm_count > (((unsigned long)(len_alarm)) << 20)) f_alarm_on &= 0xFE;
	ldi R24,20
	ldi R25,0
	lds R2,_len_alarm
	clr R3
	clr R4
	clr R5
	st -y,R24
	movw R16,R2
	movw R18,R4
	rcall lsl32
	lds R4,_alarm_count+2
	lds R5,_alarm_count+2+1
	lds R2,_alarm_count
	lds R3,_alarm_count+1
	cp R16,R2
	cpc R17,R3
	cpc R18,R4
	cpc R19,R5
	brsh L16
	.dbline 94
	lds R24,_f_alarm_on
	andi R24,254
	sts _f_alarm_on,R24
L16:
	.dbline 95
;  }
L14:
	.dbline 96
;  if(f_mus&0x01) mus_count += d_main_count;
	lds R2,_f_mus
	sbrs R2,0
	rjmp L18
	.dbline 96
	ldi R20,0
	ldi R21,156
	ldi R22,0
	ldi R23,0
	lds R4,_mus_count+2
	lds R5,_mus_count+2+1
	lds R2,_mus_count
	lds R3,_mus_count+1
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	sts _mus_count+1,R3
	sts _mus_count,R2
	sts _mus_count+2+1,R5
	sts _mus_count+2,R4
L18:
	.dbline 97
;  if(f_rs232&0x02)
	lds R2,_f_rs232
	sbrs R2,1
	rjmp L20
	.dbline 98
;  {
	.dbline 99
;   	rs232_count += d_main_count;
	ldi R20,0
	ldi R21,156
	ldi R22,0
	ldi R23,0
	lds R4,_rs232_count+2
	lds R5,_rs232_count+2+1
	lds R2,_rs232_count
	lds R3,_rs232_count+1
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	sts _rs232_count+1,R3
	sts _rs232_count,R2
	sts _rs232_count+2+1,R5
	sts _rs232_count+2,R4
	.dbline 100
; 	if(rs232_count > d_rs232)
	ldi R20,80
	ldi R21,195
	ldi R22,0
	ldi R23,0
	cp R20,R2
	cpc R21,R3
	cpc R22,R4
	cpc R23,R5
	brsh L22
	.dbline 101
; 	{
	.dbline 102
; 	 	f_rs232 |= 0x01;
	lds R24,_f_rs232
	ori R24,1
	sts _f_rs232,R24
	.dbline 103
; 		f_rs232 &= 0xFD;
	andi R24,253
	sts _f_rs232,R24
	.dbline 104
; 		UCSRB = 0x48;// +,  +
	ldi R24,72
	out 0xa,R24
	.dbline 105
; 	}
L22:
	.dbline 106
L20:
	.dbline -2
L13:
	rcall pop_gset2
	ld R0,y+
	out 0x3f,R0
	ld R30,y+
	ld R25,y+
	ld R24,y+
	ld R19,y+
	ld R18,y+
	ld R17,y+
	ld R16,y+
	ld R9,y+
	ld R8,y+
	ld R5,y+
	ld R4,y+
	ld R3,y+
	ld R2,y+
	ld R1,y+
	ld R0,y+
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e init_devices _init_devices fV
	.even
_init_devices::
	.dbline -1
	.dbline 111
;  }
; }
; 
; //call this routine to initialize all peripherals
; void init_devices(void)
; {
	.dbline 113
;  //stop errant interrupts until set up
;  CLI(); //disable all interrupts
	cli
	.dbline 114
;  port_init();
	rcall _port_init
	.dbline 115
;  watchdog_init();
	rcall _watchdog_init
	.dbline 116
;  spi_init();
	rcall _spi_init
	.dbline 117
;  uart0_init();
	rcall _uart0_init
	.dbline 118
;  timer0_init();
	rcall _timer0_init
	.dbline 119
;  timer1_init();
	rcall _timer1_init
	.dbline 121
; 
;  MCUCR = 0x02;//    
	ldi R24,2
	out 0x35,R24
	.dbline 122
;  GICR  = 0x40;//   int0
	ldi R24,64
	out 0x3b,R24
	.dbline 123
;  TIMSK = 0x01; //timer interrupt sources
	ldi R24,1
	out 0x39,R24
	.dbline 124
;  SEI(); //re-enable interrupts
	sei
	.dbline 125
;  init_display();
	rcall _init_display
	.dbline -2
L24:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\main.c
_temp_main_char::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\main.c
	.dbsym e temp_main_char _temp_main_char c
_temp_main_char_2::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\main.c
	.dbsym e temp_main_char_2 _temp_main_char_2 c
_temp_main_char_3::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\main.c
	.dbsym e temp_main_char_3 _temp_main_char_3 c
_temp_main_char_4::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\main.c
	.dbsym e temp_main_char_4 _temp_main_char_4 c
	.area text(rom, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\main.c
	.dbfunc e main _main fV
	.even
_main::
	sbiw R28,3
	.dbline -1
	.dbline 132
;  //all peripherals are now initialized
; }
; 
; unsigned char temp_main_char = 0, temp_main_char_2 = 0, temp_main_char_3 = 0, temp_main_char_4 = 0;
; 
; void main()
; {
	.dbline 133
;  	init_devices();
	rcall _init_devices
	.dbline 134
; 	read_eeprom_data();
	rcall _read_eeprom_data
	.dbline 136
; 	
; 	wr_int2max(0x09, 0x00);// .
	clr R18
	ldi R16,9
	rcall _wr_int2max
	.dbline 137
; 	wr_int2max(0x01, 0x7E);//1 = O
	ldi R18,126
	ldi R16,1
	rcall _wr_int2max
	.dbline 138
; 	wr_int2max(0x02, 0x05);//2 = r
	ldi R18,5
	ldi R16,2
	rcall _wr_int2max
	.dbline 139
; 	wr_int2max(0x03, 0x7E);//3 = O
	ldi R18,126
	ldi R16,3
	rcall _wr_int2max
	.dbline 140
; 	wr_int2max(0x04, 0x0E);//4 = L
	ldi R18,14
	ldi R16,4
	rcall _wr_int2max
	.dbline 141
; 	wr_int2max(0x05, 0x7E);//5 = O
	ldi R18,126
	ldi R16,5
	rcall _wr_int2max
	.dbline 142
; 	wr_int2max(0x06, 0x5F);//6 = G
	ldi R18,95
	ldi R16,6
	rcall _wr_int2max
	.dbline 143
; 	wr_int2max(0x07, 0x30);//7 = I
	ldi R18,48
	ldi R16,7
	rcall _wr_int2max
	.dbline 144
; 	wr_int2max(0x08, 0x7E);//1 = O
	ldi R18,126
	ldi R16,8
	rcall _wr_int2max
	.dbline 145
	clr R2
	clr R3
	sts _i2+1,R3
	sts _i2,R2
	rjmp L29
L26:
	.dbline 145
	wdr
L27:
	.dbline 145
	lds R24,_i2
	lds R25,_i2+1
	adiw R24,1
	sts _i2+1,R25
	sts _i2,R24
L29:
	.dbline 145
; 	for(i2 = 0; i2 < 65000; i2++) WDR();
	lds R24,_i2
	lds R25,_i2+1
	cpi R24,232
	ldi R30,253
	cpc R25,R30
	brlo L26
	.dbline 146
; 	init_display();
	rcall _init_display
	.dbline 148
; 	
; 	WR_DS1307(control_reg_addr, control_reg_val);
	ldi R18,144
	ldi R16,7
	rcall _WR_DS1307
	.dbline 149
; 	WR_DS1307(addr_secs, (RE_DS1307(addr_secs)&0x7F));
	clr R16
	rcall _RE_DS1307
	mov R18,R16
	andi R18,127
	clr R16
	rcall _WR_DS1307
	.dbline 150
; 	WR_DS1307(addr_hours, (RE_DS1307(addr_hours)&0xBF));
	ldi R16,2
	rcall _RE_DS1307
	mov R18,R16
	andi R18,191
	ldi R16,2
	rcall _WR_DS1307
	rjmp L31
L30:
	.dbline 153
; 	
; 	while(1)
; 	{
	.dbline 155
; //-------------------------------- --------------------------------
; 		if(dots_count >= d_VDs)
	ldi R20,32
	ldi R21,161
	ldi R22,7
	ldi R23,0
	lds R4,_dots_count+2
	lds R5,_dots_count+2+1
	lds R2,_dots_count
	lds R3,_dots_count+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brlo L33
	.dbline 156
; 		{
	.dbline 157
; 		 	VDs(0);// 
	clr R16
	rcall _VDs
	.dbline 158
; 			dots_count = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	sts _dots_count+1,R21
	sts _dots_count,R20
	sts _dots_count+2+1,R23
	sts _dots_count+2,R22
	.dbline 159
; 			if(!(f_disp_off&0x02)) set_intensity();//  
	lds R2,_f_disp_off
	sbrc R2,1
	rjmp L35
	.dbline 159
	rcall _set_intensity
	rjmp L36
L35:
	.dbline 160
; 			else wr_int2max(0x0A, 0x00);//  = 0
	clr R18
	ldi R16,10
	rcall _wr_int2max
L36:
	.dbline 161
; 			temperature = ((RE_TEMP()&0x7FFF) >> 3);
	rcall _RE_TEMP
	movw R24,R16
	andi R25,127
	lsr R25
	ror R24
	lsr R25
	ror R24
	lsr R25
	ror R24
	sts _temperature+1,R25
	sts _temperature,R24
	.dbline 162
; 		}
L33:
	.dbline 165
; //-------------------------------- --------------------------------
; //-----------------------------   ---------------------------
; 		if((flags&0x03) == 0x01)
	lds R24,_flags
	andi R24,3
	cpi R24,1
	breq X1
	rjmp L37
X1:
	.dbline 166
; 		{
	.dbline 167
; 		 	flags &= 0xFE;//   /
	lds R24,_flags
	andi R24,254
	sts _flags,R24
	.dbline 168
; 			if(view != 3) show_dig_1(hour_1, hour_2, min_1, min_2);
	lds R24,_view
	cpi R24,3
	breq L39
	.dbline 168
	lds R2,_min_2
	std y+2,R2
	lds R2,_min_1
	std y+0,R2
	lds R18,_hour_2
	lds R16,_hour_1
	rcall _show_dig_1
L39:
	.dbline 169
; 			if(view == 0) show_dig_2(date_1, date_2|0x80, mon_1, mon_2);
	lds R2,_view
	tst R2
	brne L41
	.dbline 169
	lds R2,_mon_2
	std y+2,R2
	lds R2,_mon_1
	std y+0,R2
	lds R18,_date_2
	ori R18,128
	lds R16,_date_1
	rcall _show_dig_2
L41:
	.dbline 170
; 			if(view == 1) show_dig_2(0x0F, 0x0F, sec_1, sec_2);
	lds R24,_view
	cpi R24,1
	brne L43
	.dbline 170
	lds R2,_sec_2
	std y+2,R2
	lds R2,_sec_1
	std y+0,R2
	ldi R18,15
	ldi R16,15
	rcall _show_dig_2
L43:
	.dbline 171
; 			if(view == 2) show_dig_2(0x0F, 0x0F, (temperature / 10), ((temperature - ((temperature / 10) * 10))|0x80));
	lds R24,_view
	cpi R24,2
	brne L45
	.dbline 171
	ldi R18,10
	ldi R19,0
	lds R16,_temperature
	lds R17,_temperature+1
	rcall div16u
	movw R2,R16
	ldi R16,10
	ldi R17,0
	movw R18,R2
	rcall empy16s
	lds R24,_temperature
	lds R25,_temperature+1
	sub R24,R16
	sbc R25,R17
	ori R24,128
	std y+2,R24
	std y+0,R2
	ldi R18,15
	ldi R16,15
	rcall _show_dig_2
L45:
	.dbline 172
; 			if(view == 3)
	lds R24,_view
	cpi R24,3
	brne L47
	.dbline 173
; 			{
	.dbline 174
; 			 	show_dig_1(date_1, date_2, mon_1, mon_2);
	lds R2,_mon_2
	std y+2,R2
	lds R2,_mon_1
	std y+0,R2
	lds R18,_date_2
	lds R16,_date_1
	rcall _show_dig_1
	.dbline 175
; 				show_dig_2(0x02, 0x00, year_1, year_2);
	lds R2,_year_2
	std y+2,R2
	lds R2,_year_1
	std y+0,R2
	clr R18
	ldi R16,2
	rcall _show_dig_2
	.dbline 176
; 			}
L47:
	.dbline 177
; 		}
L37:
	.dbline 178
; 		if(flags&0x02)
	lds R2,_flags
	sbrs R2,1
	rjmp L49
	.dbline 179
; 		{
	.dbline 180
; 		 	if(menu_st == set_hours) show_dig_1((hour_1|0x80), (hour_2|0x80), min_1, min_2);// 
	lds R24,_menu_st
	cpi R24,1
	brne L51
	.dbline 180
	lds R2,_min_2
	std y+2,R2
	lds R2,_min_1
	std y+0,R2
	lds R18,_hour_2
	ori R18,128
	lds R16,_hour_1
	ori R16,128
	rcall _show_dig_1
L51:
	.dbline 181
; 			if(menu_st == set_mins) show_dig_1(hour_1, hour_2, (min_1|0x80), (min_2|0x80));// 
	lds R24,_menu_st
	cpi R24,2
	brne L53
	.dbline 181
	lds R24,_min_2
	ori R24,128
	std y+2,R24
	lds R24,_min_1
	ori R24,128
	std y+0,R24
	lds R18,_hour_2
	lds R16,_hour_1
	rcall _show_dig_1
L53:
	.dbline 182
; 			if(menu_st == set_secs) show_dig_1(0x0A, 0x0A, sec_1|0x80, sec_2|0x80);// 
	lds R24,_menu_st
	cpi R24,3
	brne L55
	.dbline 182
	lds R24,_sec_2
	ori R24,128
	std y+2,R24
	lds R24,_sec_1
	ori R24,128
	std y+0,R24
	ldi R18,10
	ldi R16,10
	rcall _show_dig_1
L55:
	.dbline 183
; 			if(menu_st == set_date) show_dig_1((date_1|0x80), (date_2|0x80), mon_1, mon_2);// 
	lds R24,_menu_st
	cpi R24,4
	brne L57
	.dbline 183
	lds R2,_mon_2
	std y+2,R2
	lds R2,_mon_1
	std y+0,R2
	lds R18,_date_2
	ori R18,128
	lds R16,_date_1
	ori R16,128
	rcall _show_dig_1
L57:
	.dbline 184
; 			if(menu_st == set_day) show_dig_1(0x0F, 0x0F, 0x0F, day|0x80);//  
	lds R24,_menu_st
	cpi R24,5
	brne L59
	.dbline 184
	lds R24,_day
	ori R24,128
	std y+2,R24
	ldi R24,15
	std y+0,R24
	ldi R18,15
	ldi R16,15
	rcall _show_dig_1
L59:
	.dbline 185
; 			if(menu_st == set_mons) show_dig_1(date_1, date_2, (mon_1|0x80), (mon_2|0x80));// 
	lds R24,_menu_st
	cpi R24,6
	brne L61
	.dbline 185
	lds R24,_mon_2
	ori R24,128
	std y+2,R24
	lds R24,_mon_1
	ori R24,128
	std y+0,R24
	lds R18,_date_2
	lds R16,_date_1
	rcall _show_dig_1
L61:
	.dbline 186
; 			if(menu_st == set_years) show_dig_1(0x02, 0x00, year_1|0x80, year_2|0x80);// 
	lds R24,_menu_st
	cpi R24,7
	brne L63
	.dbline 186
	lds R24,_year_2
	ori R24,128
	std y+2,R24
	lds R24,_year_1
	ori R24,128
	std y+0,R24
	clr R18
	ldi R16,2
	rcall _show_dig_1
L63:
	.dbline 188
; //------------      ------------
; 			al_num_1 = (num_alarm + 1) / 10;
	ldi R17,10
	lds R16,_num_alarm
	subi R16,255    ; addi 1
	rcall div8u
	sts _al_num_1,R16
	.dbline 189
; 			al_num_2 = ((num_alarm + 1) - (al_num_1 * 10));
	mov R2,R16
	ldi R24,10
	mul R24,R2
	lds R24,_num_alarm
	subi R24,255    ; addi 1
	sub R24,R0
	sts _al_num_2,R24
	.dbline 190
; 			al_type_1 = type_alarm / 10;
	ldi R17,10
	lds R16,_type_alarm
	rcall div8u
	sts _al_type_1,R16
	.dbline 191
; 			al_type_2 = (type_alarm - (al_type_1 * 10));
	mov R2,R16
	ldi R24,10
	mul R24,R2
	lds R2,_type_alarm
	sub R2,R0
	sts _al_type_2,R2
	.dbline 192
; 			al_hour_1 = al_hour / 10;
	ldi R17,10
	lds R16,_al_hour
	rcall div8u
	sts _al_hour_1,R16
	.dbline 193
; 			al_hour_2 = (al_hour - (al_hour_1 * 10));
	mov R2,R16
	ldi R24,10
	mul R24,R2
	lds R2,_al_hour
	sub R2,R0
	sts _al_hour_2,R2
	.dbline 194
; 			al_min_1 = al_min / 10;
	ldi R17,10
	lds R16,_al_min
	rcall div8u
	sts _al_min_1,R16
	.dbline 195
; 			al_min_2 = (al_min - (al_min_1 * 10));
	mov R2,R16
	ldi R24,10
	mul R24,R2
	lds R2,_al_min
	sub R2,R0
	sts _al_min_2,R2
	.dbline 196
; 			al_date_1 = al_date / 10;
	ldi R17,10
	lds R16,_al_date
	rcall div8u
	sts _al_date_1,R16
	.dbline 197
; 			al_date_2 = (al_date - (al_date_1 * 10));
	mov R2,R16
	ldi R24,10
	mul R24,R2
	lds R2,_al_date
	sub R2,R0
	sts _al_date_2,R2
	.dbline 198
; 			al_mon_1 = al_mon / 10;
	ldi R17,10
	lds R16,_al_mon
	rcall div8u
	sts _al_mon_1,R16
	.dbline 199
; 			al_mon_2 = (al_mon - (al_mon_1 * 10));
	mov R2,R16
	ldi R24,10
	mul R24,R2
	lds R2,_al_mon
	sub R2,R0
	sts _al_mon_2,R2
	.dbline 201
; //------------      ------------
; 			if(menu_st == set_alarm_num) show_dig_1(0x0C, 0x0A, al_num_1|0x80, al_num_2|0x80);//  
	lds R24,_menu_st
	cpi R24,8
	brne L65
	.dbline 201
	lds R24,_al_num_2
	ori R24,128
	std y+2,R24
	lds R24,_al_num_1
	ori R24,128
	std y+0,R24
	ldi R18,10
	ldi R16,12
	rcall _show_dig_1
L65:
	.dbline 202
; 			if(menu_st == set_alarm_type) show_dig_1(0x0F, 0x0F, 0x0F, al_type_2|0x80);//  
	lds R24,_menu_st
	cpi R24,9
	brne L67
	.dbline 202
	lds R24,_al_type_2
	ori R24,128
	std y+2,R24
	ldi R24,15
	std y+0,R24
	ldi R18,15
	ldi R16,15
	rcall _show_dig_1
L67:
	.dbline 203
; 			if(menu_st == set_alarm_hours) show_dig_1((al_hour_1|0x80), (al_hour_2|0x80), al_min_1, al_min_2);//  
	lds R24,_menu_st
	cpi R24,10
	brne L69
	.dbline 203
	lds R2,_al_min_2
	std y+2,R2
	lds R2,_al_min_1
	std y+0,R2
	lds R18,_al_hour_2
	ori R18,128
	lds R16,_al_hour_1
	ori R16,128
	rcall _show_dig_1
L69:
	.dbline 204
; 			if(menu_st == set_alarm_mins) show_dig_1(al_hour_1, al_hour_2, (al_min_1|0x80), (al_min_2|0x80));//  
	lds R24,_menu_st
	cpi R24,11
	brne L71
	.dbline 204
	lds R24,_al_min_2
	ori R24,128
	std y+2,R24
	lds R24,_al_min_1
	ori R24,128
	std y+0,R24
	lds R18,_al_hour_2
	lds R16,_al_hour_1
	rcall _show_dig_1
L71:
	.dbline 205
; 			if(menu_st == set_alarm_date) show_dig_1((al_date_1|0x80), (al_date_2|0x80), al_mon_1, al_mon_2);//  
	lds R24,_menu_st
	cpi R24,12
	brne L73
	.dbline 205
	lds R2,_al_mon_2
	std y+2,R2
	lds R2,_al_mon_1
	std y+0,R2
	lds R18,_al_date_2
	ori R18,128
	lds R16,_al_date_1
	ori R16,128
	rcall _show_dig_1
L73:
	.dbline 206
; 			if(menu_st == set_alarm_mons) show_dig_1(al_date_1, al_date_2, (al_mon_1|0x80), (al_mon_2|0x80));//  
	lds R24,_menu_st
	cpi R24,13
	brne L75
	.dbline 206
	lds R24,_al_mon_2
	ori R24,128
	std y+2,R24
	lds R24,_al_mon_1
	ori R24,128
	std y+0,R24
	lds R18,_al_date_2
	lds R16,_al_date_1
	rcall _show_dig_1
L75:
	.dbline 207
; 			i = menu_st / 10;
	ldi R17,10
	lds R16,_menu_st
	rcall div8u
	sts _i,R16
	.dbline 208
; 			j = (menu_st - (i * 10));
	mov R2,R16
	ldi R24,10
	mul R24,R2
	lds R2,_menu_st
	sub R2,R0
	sts _j,R2
	.dbline 209
; 			show_dig_2(0x05, 0x0A, i, j);
	std y+2,R2
	mov R2,R16
	std y+0,R2
	ldi R18,10
	ldi R16,5
	rcall _show_dig_2
	.dbline 210
; 		}
L49:
	.dbline 213
; //-----------------------------   ---------------------------
; //-------------------------------- ------------------------------
; 		if((!(f_alarm_on&0x01))&&(!(flags&0x02)))
	lds R2,_f_alarm_on
	sbrc R2,0
	rjmp L77
	lds R2,_flags
	sbrc R2,1
	rjmp L77
	.dbline 214
; 		{
	.dbline 215
; 			for(i = 0; i < 16; i++)
	clr R2
	sts _i,R2
	rjmp L82
L79:
	.dbline 216
; 			{
	.dbline 217
; 			 	if(mas_type_alarm[i] != alarm_type_off)
	ldi R24,<_mas_type_alarm
	ldi R25,>_mas_type_alarm
	lds R30,_i
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	tst R2
	brne X2
	rjmp L83
X2:
	.dbline 218
; 				{
	.dbline 219
; 				 	j = ((hour_1 * 10) + hour_2);
	lds R2,_hour_1
	ldi R24,10
	mul R24,R2
	lds R2,_hour_2
	mov R3,R0
	add R3,R2
	sts _j,R3
	.dbline 220
; 					k = ((min_1 * 10) + min_2);
	lds R2,_min_1
	mul R24,R2
	lds R2,_min_2
	mov R3,R0
	add R3,R2
	sts _k,R3
	.dbline 221
; 					l = ((date_1 * 10) + date_2);
	lds R2,_date_1
	mul R24,R2
	lds R2,_date_2
	mov R3,R0
	add R3,R2
	sts _l,R3
	.dbline 222
; 					m = ((mon_1 * 10) + mon_2);
	lds R2,_mon_1
	mul R24,R2
	lds R2,_mon_2
	mov R3,R0
	add R3,R2
	sts _m,R3
	.dbline 223
; 					if((mas_hour_alarm[i] == j)&&(mas_min_alarm[i] == k))
	ldi R24,<_mas_hour_alarm
	ldi R25,>_mas_hour_alarm
	lds R30,_i
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	lds R3,_j
	cp R2,R3
	breq X3
	rjmp L85
X3:
	ldi R24,<_mas_min_alarm
	ldi R25,>_mas_min_alarm
	lds R30,_i
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	lds R3,_k
	cp R2,R3
	breq X4
	rjmp L85
X4:
	.dbline 224
; 					{
	.dbline 225
; 					 	if((mas_type_alarm[i] == alarm_type_ever)||
	ldi R24,<_mas_type_alarm
	ldi R25,>_mas_type_alarm
	lds R30,_i
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	clr R3
	mov R24,R2
	cpi R24,1
	brne X5
	rjmp L93
X5:
	cpi R24,2
	brne L92
	lds R24,_day
	cpi R24,6
	breq L92
	cpi R24,7
	breq X6
	rjmp L93
X6:
L92:
	ldi R24,<_mas_type_alarm
	ldi R25,>_mas_type_alarm
	lds R30,_i
	clr R31
	add R30,R24
	adc R31,R25
	ldd R24,z+0
	cpi R24,3
	brne L94
	lds R24,_day
	cpi R24,6
	breq L93
	cpi R24,7
	breq L93
L94:
	ldi R24,<_mas_type_alarm
	ldi R25,>_mas_type_alarm
	lds R30,_i
	clr R31
	add R30,R24
	adc R31,R25
	ldd R24,z+0
	cpi R24,4
	brne L87
	ldi R24,<_mas_date_alarm
	ldi R25,>_mas_date_alarm
	lds R30,_i
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	lds R3,_l
	cp R2,R3
	brne L87
	ldi R24,<_mas_mon_alarm
	ldi R25,>_mas_mon_alarm
	lds R30,_i
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	lds R3,_m
	cp R2,R3
	brne L87
L93:
	.dbline 229
; 						((mas_type_alarm[i] == alarm_type_mor)&&(day != 0x06)&&(day != 0x07))||
; 						((mas_type_alarm[i] == alarm_type_dayoff)&&((day == 0x06)||(day == 0x07)))||
; 						((mas_type_alarm[i] == alarm_type_sin)&&(mas_date_alarm[i] == l)&&(mas_mon_alarm[i] == m)))
; 							f_alarm_on |= 0x01;
	lds R24,_f_alarm_on
	ori R24,1
	sts _f_alarm_on,R24
L87:
	.dbline 230
	clr R2
	lds R3,_sec_1
	cp R2,R3
	brlo L98
	ldi R24,5
	lds R2,_sec_2
	cp R24,R2
	brlo L98
	mov R24,R2
	cpi R24,1
	brsh L95
L98:
	.dbline 230
; 						if((sec_1 > 0)||(sec_2 > 5)||(sec_2 < 1)) f_alarm_on &= 0xFE;
	lds R24,_f_alarm_on
	andi R24,254
	sts _f_alarm_on,R24
L95:
	.dbline 231
; 					}
L85:
	.dbline 232
; 				}
L83:
	.dbline 233
; 				alarm_count = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	sts _alarm_count+1,R21
	sts _alarm_count,R20
	sts _alarm_count+2+1,R23
	sts _alarm_count+2,R22
	rjmp L100
L99:
	.dbline 235
; 				while(f_alarm_on&0x01)
; 				{
	.dbline 236
; 					show_dig_1(0x0A, 0x0A, 0x0A, 0x0A);
	ldi R24,10
	std y+2,R24
	std y+0,R24
	ldi R18,10
	ldi R16,10
	rcall _show_dig_1
	.dbline 237
; 					show_dig_2(0x0A, 0x0A, 0x0A, 0x0A);
	ldi R24,10
	std y+2,R24
	std y+0,R24
	ldi R18,10
	ldi R16,10
	rcall _show_dig_2
	.dbline 238
; 					if((music(0, 32))||(music(0, 59))||
	ldi R18,32
	clr R16
	rcall _music
	tst R16
	brne L106
	ldi R18,59
	clr R16
	rcall _music
	tst R16
	brne L106
	ldi R18,111
	ldi R16,32
	rcall _music
	tst R16
	brne L106
	ldi R18,121
	ldi R16,60
	rcall _music
	tst R16
	breq L102
L106:
	.dbline 240
; 					(music(32, 111))||(music(60, 121)))
; 					{
	.dbline 241
; 					 	TCCR1B = 0x00;// 
	clr R2
	out 0x2e,R2
	.dbline 242
; 						break;
	rjmp L101
L102:
	.dbline 244
	clr R2
	out 0x2e,R2
	.dbline 245
L100:
	.dbline 234
	lds R2,_f_alarm_on
	sbrc R2,0
	rjmp L99
L101:
	.dbline 246
L80:
	.dbline 215
	lds R24,_i
	subi R24,255    ; addi 1
	sts _i,R24
L82:
	.dbline 215
	lds R24,_i
	cpi R24,16
	brsh X7
	rjmp L79
X7:
	.dbline 247
; 					}
; 					TCCR1B = 0x00;// 
; 				}
; 			}
; 		}
L77:
	.dbline 249
	rcall _sets
	.dbline 250
	rcall _rs232_handler
	.dbline 251
	wdr
	.dbline 252
L31:
	.dbline 152
	rjmp L30
X0:
	.dbline -2
L25:
	adiw R28,3
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e music _music fc
;         temp_i -> R10,R11
;         temp_j -> R12
;         temp_k -> y+2
;           last -> R14
;          first -> y+13
	.even
_music::
	rcall push_arg4
	rcall push_gset5
	mov R14,R18
	sbiw R28,3
	.dbline -1
	.dbline 256
; //-------------------------------- ------------------------------
; 		sets();// /, , 
; 		rs232_handler();//  
; 	 	WDR();
; 	}
; }
; 
; unsigned char music(unsigned char first, unsigned char last)
; {
	.dbline 257
;  	unsigned char temp_j = 0, temp_k = 0;
	clr R12
	.dbline 257
	clr R2
	std y+2,R2
	.dbline 258
; 	unsigned int temp_i = 0;
	clr R10
	clr R11
	.dbline 259
; 	for(temp_j = first; temp_j < last; temp_j++)
	ldd R12,y+13
	rjmp L111
L108:
	.dbline 260
; 	{
	.dbline 262
; 		//if((first == 0)&&(temp_j == 62)) temp_j++;
; 		if((first == 0)&&(temp_j == 30)&&(last > 32)) temp_j++;
	ldd R0,y+13
	tst R0
	brne L112
	mov R24,R12
	cpi R24,30
	brne L112
	ldi R24,32
	cp R24,R14
	brsh L112
	.dbline 262
	inc R12
L112:
	.dbline 263
; 		if((first == 60)&&(temp_j == 60)&&(last == 121)) temp_j++;
	ldd R24,y+13
	cpi R24,60
	brne L114
	mov R24,R12
	cpi R24,60
	brne L114
	mov R24,R14
	cpi R24,121
	brne L114
	.dbline 263
	inc R12
L114:
	.dbline 264
; 		if(keys()||(!(f_alarm_on&0x01)))
	rcall _keys
	tst R16
	brne L118
	lds R2,_f_alarm_on
	sbrc R2,0
	rjmp L116
L118:
	.dbline 265
; 		{
	.dbline 266
; 			f_alarm_on &= 0xFE;
	lds R24,_f_alarm_on
	andi R24,254
	sts _f_alarm_on,R24
	.dbline 267
; 			return 1;
	ldi R16,1
	rjmp L107
L116:
	.dbline 269
; 		}
; 		EEPROM_READ((int)&EE_mus_note[temp_j], temp_k);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,254  ; offset = 2
	sbci R19,255
	ldi R24,<_EE_mus_note
	ldi R25,>_EE_mus_note
	mov R16,R12
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMReadBytes
	.dbline 270
; 		temp_i = note_mas[temp_k];
	ldd R2,y+2
	ldi R24,2
	mul R24,R2
	movw R30,R0
	ldi R24,<_note_mas
	ldi R25,>_note_mas
	add R30,R24
	adc R31,R25
	ldd R10,z+0
	ldd R11,z+1
	.dbline 271
; 		TCCR1B = 0x00;// 
	clr R2
	out 0x2e,R2
	.dbline 273
; 		
; 		EEPROM_READ((int)&EE_mus_long[temp_j], temp_k);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,254  ; offset = 2
	sbci R19,255
	ldi R24,<_EE_mus_long
	ldi R25,>_EE_mus_long
	mov R16,R12
	clr R17
	add R16,R24
	adc R17,R25
	rcall _EEPROMReadBytes
	.dbline 275
; 		
; 		if((first == 0)&&(temp_j == 31)&&(last > 32)) temp_k = 0x1F;
	ldd R0,y+13
	tst R0
	brne L119
	mov R24,R12
	cpi R24,31
	brne L119
	ldi R24,32
	cp R24,R14
	brsh L119
	.dbline 275
	ldi R24,31
	std y+2,R24
L119:
	.dbline 276
; 		if((first == 32)&&(temp_j == 110)&&(last == 111)) temp_k = 0x1D;
	ldd R24,y+13
	cpi R24,32
	brne L121
	mov R24,R12
	cpi R24,110
	brne L121
	mov R24,R14
	cpi R24,111
	brne L121
	.dbline 276
	ldi R24,29
	std y+2,R24
L121:
	.dbline 277
; 		if((first == 60)&&(temp_j == 61)&&(last == 121)) temp_k = 0xEC;
	ldd R24,y+13
	cpi R24,60
	brne L123
	mov R24,R12
	cpi R24,61
	brne L123
	mov R24,R14
	cpi R24,121
	brne L123
	.dbline 277
	ldi R24,236
	std y+2,R24
L123:
	.dbline 279
; 		
; 		f_mus |= 0x01;
	lds R24,_f_mus
	ori R24,1
	sts _f_mus,R24
	.dbline 280
; 		mus_count = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	sts _mus_count+1,R21
	sts _mus_count,R20
	sts _mus_count+2+1,R23
	sts _mus_count+2,R22
	rjmp L126
L125:
	.dbline 282
; 		while(mus_count < long_note_mas[temp_k >> 4])
; 		{
	.dbline 283
; 			if(keys()||(!(f_alarm_on&0x01)))
	rcall _keys
	tst R16
	brne L130
	lds R2,_f_alarm_on
	sbrc R2,0
	rjmp L128
L130:
	.dbline 284
; 			{
	.dbline 285
; 				f_alarm_on &= 0xFE;
	lds R24,_f_alarm_on
	andi R24,254
	sts _f_alarm_on,R24
	.dbline 286
; 				return 1;
	ldi R16,1
	rjmp L107
L128:
	.dbline 288
	wdr
	.dbline 289
L126:
	.dbline 281
	ldd R24,y+2
	swap R24
	andi R24,#0x0F
	ldi R25,4
	mul R25,R24
	movw R30,R0
	ldi R24,<_long_note_mas
	ldi R25,>_long_note_mas
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	lds R8,_mus_count+2
	lds R9,_mus_count+2+1
	lds R6,_mus_count
	lds R7,_mus_count+1
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brlo L125
	.dbline 290
; 			}
; 			WDR();
; 		}
; 		f_mus &= 0xFE;
	lds R24,_f_mus
	andi R24,254
	sts _f_mus,R24
	.dbline 293
; 		
; 		
; 		TCCR1B = 0x11;// 
	ldi R24,17
	out 0x2e,R24
	.dbline 294
; 		OCR1AH = (temp_i >> 8);
	movw R2,R10
	mov R2,R3
	clr R3
	out 0x2b,R2
	.dbline 295
;  		OCR1AL = (temp_i&0x00FF);
	movw R24,R10
	andi R25,0
	out 0x2a,R24
	.dbline 298
; 		
; 		
; 		f_mus |= 0x01;
	lds R24,_f_mus
	ori R24,1
	sts _f_mus,R24
	.dbline 299
; 		mus_count = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	sts _mus_count+1,R21
	sts _mus_count,R20
	sts _mus_count+2+1,R23
	sts _mus_count+2,R22
	rjmp L132
L131:
	.dbline 301
; 		while(mus_count < long_note_mas[temp_k&0x0F])
; 		{
	.dbline 302
; 			if(keys()||(!(f_alarm_on&0x01)))
	rcall _keys
	tst R16
	brne L136
	lds R2,_f_alarm_on
	sbrc R2,0
	rjmp L134
L136:
	.dbline 303
; 			{
	.dbline 304
; 				f_alarm_on &= 0xFE;
	lds R24,_f_alarm_on
	andi R24,254
	sts _f_alarm_on,R24
	.dbline 305
; 				return 1;
	ldi R16,1
	rjmp L107
L134:
	.dbline 307
	wdr
	.dbline 308
L132:
	.dbline 300
	ldd R24,y+2
	andi R24,15
	ldi R25,4
	mul R25,R24
	movw R30,R0
	ldi R24,<_long_note_mas
	ldi R25,>_long_note_mas
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	lds R8,_mus_count+2
	lds R9,_mus_count+2+1
	lds R6,_mus_count
	lds R7,_mus_count+1
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brlo L131
	.dbline 309
L109:
	.dbline 259
	inc R12
L111:
	.dbline 259
	cp R12,R14
	brsh X8
	rjmp L108
X8:
	.dbline 310
; 			}
; 			WDR();
; 		}
; 	}
; 	if(!(f_alarm_on&0x01))
	lds R2,_f_alarm_on
	sbrc R2,0
	rjmp L137
	.dbline 311
; 	{
	.dbline 312
; 		TCCR1B = 0x00;// 
	clr R2
	out 0x2e,R2
	.dbline 313
; 		return 1;
	ldi R16,1
	rjmp L107
L137:
	.dbline 315
; 	}
; 	return 0;
	clr R16
	.dbline -2
L107:
	adiw R28,3
	rcall pop_gset5
	adiw R28,4
	.dbline 0 ; func end
	ret
	.dbsym r temp_i 10 i
	.dbsym r temp_j 12 c
	.dbsym l temp_k 2 c
	.dbsym r last 14 c
	.dbsym l first 13 c
	.dbend
