//**********************************************************************************
//------------------------------ ------------------------------------
extern unsigned char i, j, k, l, m;
extern unsigned int i2, j2;
extern unsigned long i3;
//------------------------------ ------------------------------------

//--------------------------  /-----------------------------
extern unsigned char mas_DS1307[7];
extern unsigned char year_1, year_2, mon_1, mon_2, date_1, date_2, day, hour_1,
	   				 hour_2, min_1, min_2, sec_1, sec_2;
extern unsigned char flags;
//--------------------------  /-----------------------------

//------------------------------  ---------------------------------
extern unsigned char view;
extern unsigned char menu_st;
extern unsigned char st_but[16];
extern unsigned char s_st_but;
extern unsigned char num_alarm;
extern unsigned char type_alarm;
//------------------------------  ---------------------------------

//--------------------------------------------------------------------------
extern unsigned long dots_count;
extern unsigned long keys_count;
extern unsigned long alarm_count;
extern unsigned long mus_count;
extern unsigned long rs232_count;
//--------------------------------------------------------------------------

//--------------------------  ------------------------------
extern unsigned char f_VDs;
extern unsigned char f_disp_off;
extern unsigned char intensity;
//--------------------------  ------------------------------

//--------------------------  ------------------------------
extern unsigned char mas_type_alarm[16];
extern unsigned char mas_hour_alarm[16];
extern unsigned char mas_min_alarm[16];
extern unsigned char mas_date_alarm[16];
extern unsigned char mas_mon_alarm[16];
extern unsigned char len_alarm;
extern unsigned char f_alarm_on;
extern unsigned char al_mon_1, al_mon_2, al_date_1, al_date_2, al_hour_1, al_hour_2,
	   				 al_min_1, al_min_2, al_day_1, al_day2, al_year, al_type_1,
					 al_type_2, al_num_1, al_num_2;
extern unsigned char al_mon, al_date, al_hour, al_min, al_day, al_year;
//--------------------------  ------------------------------

//--------------------------  -------------------------------
extern unsigned int temperature;
//--------------------------  -------------------------------

//---------------------------  RS-232----------------------------------
extern unsigned char rx_mas[85];
extern unsigned char tx_mas[85];
extern unsigned char rx_s;
extern unsigned char tx_s;
extern unsigned char tx_count;
extern unsigned char f_rs232;
//---------------------------  RS-232----------------------------------

//---------------------------  ---------------------------------
extern unsigned int note_mas[60];
extern unsigned long long_note_mas[16];
extern unsigned char f_mus;
//---------------------------  ---------------------------------
//**********************************************************************************

//**********************************************************************************
//--------------------------- EEPROM   ----------------------------------
//-------------------------   (EEPROM)-----------------------------
extern unsigned char EE_view;
//-------------------------   (EEPROM)-----------------------------

//----------------------   (EEPROM)-------------------------
extern unsigned char EE_type_alarm[16];
extern unsigned char EE_hour_alarm[16];
extern unsigned char EE_min_alarm[16];
extern unsigned char EE_date_alarm[16];
extern unsigned char EE_mon_alarm[16];
extern unsigned char EE_len_alarm;
//----------------------   (EEPROM)-------------------------

//------------------------   (EEPROM)---------------------------
extern unsigned char EE_mus_note[121];
extern unsigned char EE_mus_long[121];
//------------------------   (EEPROM)---------------------------
//--------------------------- EEPROM   ----------------------------------
//**********************************************************************************

//**********************************************************************************
//-------------------------------------------------------------------------

#define min_intensity 5

//-------------------------------- DS1307-------------------------------------
#define addr_secs 0x00
#define addr_mins 0x01
#define addr_hours 0x02
#define addr_day 0x03
#define addr_date 0x04
#define addr_mons 0x05
#define addr_years 0x06
#define control_reg_addr 0x07
#define control_reg_val 0x90
//-------------------------------- DS1307-------------------------------------

//---------------------------  --------------------------------
// 
#define d_main_count 39936
//   
#define d_VDs 500000
//   
#define d_keys 500000
//   RS232
#define d_rs232 50000
//---------------------------  --------------------------------

//-----------------------------  -----------------------------------
//  
#define max_view 3

#define set_none 0
//--- /---
#define set_hours 1
#define set_mins 2
#define set_secs 3
#define set_date 4
#define set_day 5
#define set_mons 6
#define set_years 7
//--- /---
//--- ---
#define set_alarm_num 8
#define set_alarm_type 9
#define set_alarm_hours 10
#define set_alarm_mins 11
#define set_alarm_date 12
#define set_alarm_mons 13
//--- ---
//--- ---
#define alarm_type_off 0
#define alarm_type_ever 1
#define alarm_type_mor 2
#define alarm_type_dayoff 3
#define alarm_type_sin 4
//--- ---
//-----------------------------  -----------------------------------
//-------------------------------------------------------------------------
//**********************************************************************************